
/*  A Bison parser, made from gram.y
    by GNU Bison version 1.28  */

#define PLPGSQL_YYBISON 1  /* Identify Bison output.  */

#define	K_ALIAS	257
#define	K_ASSIGN	258
#define	K_BEGIN	259
#define	K_CONSTANT	260
#define	K_DEBUG	261
#define	K_DECLARE	262
#define	K_DEFAULT	263
#define	K_DIAGNOSTICS	264
#define	K_DOTDOT	265
#define	K_ELSE	266
#define	K_END	267
#define	K_EXCEPTION	268
#define	K_EXECUTE	269
#define	K_EXIT	270
#define	K_FOR	271
#define	K_FROM	272
#define	K_GET	273
#define	K_IF	274
#define	K_IN	275
#define	K_INTO	276
#define	K_LOOP	277
#define	K_NOT	278
#define	K_NOTICE	279
#define	K_NULL	280
#define	K_PERFORM	281
#define	K_ROW_COUNT	282
#define	K_RAISE	283
#define	K_RECORD	284
#define	K_RENAME	285
#define	K_RESULT_OID	286
#define	K_RETURN	287
#define	K_REVERSE	288
#define	K_SELECT	289
#define	K_THEN	290
#define	K_TO	291
#define	K_TYPE	292
#define	K_WHEN	293
#define	K_WHILE	294
#define	T_FUNCTION	295
#define	T_TRIGGER	296
#define	T_CHAR	297
#define	T_BPCHAR	298
#define	T_VARCHAR	299
#define	T_LABEL	300
#define	T_STRING	301
#define	T_VARIABLE	302
#define	T_ROW	303
#define	T_ROWTYPE	304
#define	T_RECORD	305
#define	T_RECFIELD	306
#define	T_TGARGV	307
#define	T_DTYPE	308
#define	T_WORD	309
#define	T_NUMBER	310
#define	T_ERROR	311
#define	O_OPTION	312
#define	O_DUMP	313

#line 1 "gram.y"

/**********************************************************************
 * gram.y				- Parser for the PL/pgSQL
 *						  procedural language
 *
 * IDENTIFICATION
 *	  $Header: /home/projects/pgsql/cvsroot/pgsql/src/pl/plpgsql/src/gram.y,v 1.16 2001/02/19 19:49:53 tgl Exp $
 *
 *	  This software is copyrighted by Jan Wieck - Hamburg.
 *
 *	  The author hereby grants permission  to  use,  copy,	modify,
 *	  distribute,  and	license this software and its documentation
 *	  for any purpose, provided that existing copyright notices are
 *	  retained	in	all  copies  and  that	this notice is included
 *	  verbatim in any distributions. No written agreement, license,
 *	  or  royalty  fee	is required for any of the authorized uses.
 *	  Modifications to this software may be  copyrighted  by  their
 *	  author  and  need  not  follow  the licensing terms described
 *	  here, provided that the new terms are  clearly  indicated  on
 *	  the first page of each file where they apply.
 *
 *	  IN NO EVENT SHALL THE AUTHOR OR DISTRIBUTORS BE LIABLE TO ANY
 *	  PARTY  FOR  DIRECT,	INDIRECT,	SPECIAL,   INCIDENTAL,	 OR
 *	  CONSEQUENTIAL   DAMAGES  ARISING	OUT  OF  THE  USE  OF  THIS
 *	  SOFTWARE, ITS DOCUMENTATION, OR ANY DERIVATIVES THEREOF, EVEN
 *	  IF  THE  AUTHOR  HAVE BEEN ADVISED OF THE POSSIBILITY OF SUCH
 *	  DAMAGE.
 *
 *	  THE  AUTHOR  AND	DISTRIBUTORS  SPECIFICALLY	 DISCLAIM	ANY
 *	  WARRANTIES,  INCLUDING,  BUT	NOT  LIMITED  TO,  THE	IMPLIED
 *	  WARRANTIES  OF  MERCHANTABILITY,	FITNESS  FOR  A  PARTICULAR
 *	  PURPOSE,	AND NON-INFRINGEMENT.  THIS SOFTWARE IS PROVIDED ON
 *	  AN "AS IS" BASIS, AND THE AUTHOR	AND  DISTRIBUTORS  HAVE  NO
 *	  OBLIGATION   TO	PROVIDE   MAINTENANCE,	 SUPPORT,  UPDATES,
 *	  ENHANCEMENTS, OR MODIFICATIONS.
 *
 **********************************************************************/

#include <stdio.h>
#include <string.h>
#include "plpgsql.h"
#ifdef PLPGSQL_YYBISON
#include "pl_scan.c" /* GNU bison wants it here */
#endif



static	PLpgSQL_expr	*read_sqlstmt(int until, char *s, char *sqlstart);
static	PLpgSQL_stmt	*make_select_stmt(void);
static	PLpgSQL_expr	*make_tupret_expr(PLpgSQL_row *row);


#line 54 "gram.y"
typedef union {
		int32					ival;
		char					*str;
		struct
		{
			char *name;
			int  lineno;
		}						varname;
		struct
		{
			int  nalloc;
			int  nused;
			int	 *nums;
		}						intlist;
		struct
		{
			int  nalloc;
			int  nused;
			PLpgSQL_diag_item *dtitems;
		}						dtlist;
		struct
		{
			int  reverse;
			PLpgSQL_expr *expr;
		}						forilow;
		struct
		{
			char *label;
			int  n_initvars;
			int  *initvarnos;
		}						declhdr;
		PLpgSQL_type			*dtype;
		PLpgSQL_var				*var;
		PLpgSQL_row				*row;
		PLpgSQL_rec				*rec;
		PLpgSQL_recfield		*recfield;
		PLpgSQL_trigarg			*trigarg;
		PLpgSQL_expr			*expr;
		PLpgSQL_stmt			*stmt;
		PLpgSQL_stmts			*stmts;
		PLpgSQL_stmt_block		*program;
		PLpgSQL_nsitem			*nsitem;
} PLPGSQL_YYSTYPE;
#include <stdio.h>

#ifndef __cplusplus
#ifndef __STDC__
#define const
#endif
#endif



#define	PLPGSQL_YYFINAL		204
#define	PLPGSQL_YYFLAG		-32768
#define	PLPGSQL_YYNTBASE	66

#define PLPGSQL_YYTRANSLATE(x) ((unsigned)(x) <= 313 ? plpgsql_yytranslate[x] : 129)

static const char plpgsql_yytranslate[] = {     0,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,    63,
    64,     2,     2,    65,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,    60,    61,
     2,    62,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     1,     3,     4,     5,     6,
     7,     8,     9,    10,    11,    12,    13,    14,    15,    16,
    17,    18,    19,    20,    21,    22,    23,    24,    25,    26,
    27,    28,    29,    30,    31,    32,    33,    34,    35,    36,
    37,    38,    39,    40,    41,    42,    43,    44,    45,    46,
    47,    48,    49,    50,    51,    52,    53,    54,    55,    56,
    57,    58,    59
};

#if PLPGSQL_YYDEBUG != 0
static const short plpgsql_yyprhs[] = {     0,
     0,     4,     8,     9,    11,    14,    16,    19,    26,    28,
    31,    35,    37,    40,    42,    48,    50,    52,    58,    62,
    66,    72,    78,    80,    82,    84,    86,    87,    89,    91,
    93,    96,    99,   104,   105,   109,   111,   112,   115,   117,
   119,   121,   123,   124,   126,   129,   131,   133,   135,   137,
   139,   141,   143,   145,   147,   149,   151,   153,   155,   157,
   159,   161,   163,   167,   172,   178,   184,   188,   190,   192,
   194,   196,   198,   200,   209,   210,   213,   218,   224,   233,
   235,   237,   239,   240,   249,   258,   260,   262,   265,   270,
   273,   280,   286,   288,   290,   292,   294,   297,   299,   302,
   305,   308,   313,   316,   320,   322,   324,   325,   326,   327,
   328,   334,   335,   337,   339,   342,   344
};

static const short plpgsql_yyrhs[] = {    41,
    67,    70,     0,    42,    67,    70,     0,     0,    68,     0,
    68,    69,     0,    69,     0,    58,    59,     0,    71,     5,
   128,    88,    13,    60,     0,   124,     0,   124,    72,     0,
   124,    72,    73,     0,     8,     0,    73,    74,     0,    74,
     0,    61,    61,   127,    62,    62,     0,     8,     0,    75,
     0,    78,    80,    81,    85,    86,     0,    78,    30,    60,
     0,    78,    77,    60,     0,    78,     3,    17,    76,    60,
     0,    31,    79,    37,    79,    60,     0,    55,     0,    49,
     0,    55,     0,    55,     0,     0,     6,     0,    82,     0,
    54,     0,    43,    83,     0,    45,    83,     0,    44,    63,
    84,    64,     0,     0,    63,    84,    64,     0,    56,     0,
     0,    24,    26,     0,    60,     0,    87,     0,     4,     0,
     9,     0,     0,    89,     0,    89,    90,     0,    90,     0,
    70,     0,    92,     0,    98,     0,   100,     0,   101,     0,
   102,     0,   106,     0,   109,     0,   110,     0,   111,     0,
   112,     0,   118,     0,   119,     0,   107,     0,    91,     0,
    93,     0,    27,   128,   121,     0,    97,   128,     4,   121,
     0,    19,    10,   128,    94,    60,     0,    94,    65,    96,
     4,    95,     0,    96,     4,    95,     0,    28,     0,    32,
     0,    48,     0,    52,     0,    48,     0,    52,     0,    20,
   128,   122,    88,    99,    13,    20,    60,     0,     0,    12,
    88,     0,   124,    23,   128,   117,     0,   124,    40,   128,
   123,   117,     0,   124,    17,   128,   103,    21,   105,   123,
   117,     0,   104,     0,    48,     0,    55,     0,     0,   124,
    17,   128,   108,    21,    35,   123,   117,     0,   124,    17,
   128,   108,    21,    15,   123,   117,     0,    51,     0,    49,
     0,    35,   128,     0,    16,   128,   125,   126,     0,    33,
   128,     0,    29,   128,   114,   113,   115,    60,     0,    29,
   128,   114,   113,    60,     0,    47,     0,    14,     0,    25,
     0,     7,     0,   115,   116,     0,   116,     0,    65,    48,
     0,    65,    52,     0,    65,    53,     0,    88,    13,    23,
    60,     0,   120,   128,     0,    15,   128,   121,     0,    55,
     0,    57,     0,     0,     0,     0,     0,    61,    61,   127,
    62,    62,     0,     0,    46,     0,    60,     0,    39,   121,
     0,    55,     0,     0
};

#endif

#if PLPGSQL_YYDEBUG != 0
static const short plpgsql_yyrline[] = { 0,
   205,   209,   215,   216,   219,   220,   223,   229,   250,   258,
   266,   277,   283,   285,   289,   291,   293,   297,   316,   330,
   340,   345,   351,   370,   376,   384,   391,   393,   397,   401,
   403,   416,   422,   430,   432,   436,   442,   444,   448,   450,
   509,   510,   512,   520,   524,   534,   550,   552,   554,   556,
   558,   560,   562,   564,   566,   568,   570,   572,   574,   576,
   578,   580,   584,   600,   616,   633,   648,   658,   662,   668,
   677,   684,   693,   699,   716,   724,   728,   746,   765,   787,
   814,   819,   826,   899,   929,   959,   961,   967,   974,   990,
  1037,  1053,  1070,  1076,  1080,  1084,  1090,  1103,  1112,  1116,
  1120,  1126,  1130,  1143,  1156,  1158,  1162,  1166,  1170,  1174,
  1179,  1186,  1188,  1192,  1194,  1198,  1202
};
#endif


#if PLPGSQL_YYDEBUG != 0 || defined (PLPGSQL_YYERROR_VERBOSE)

static const char * const plpgsql_yytname[] = {   "$","error","$undefined.","K_ALIAS",
"K_ASSIGN","K_BEGIN","K_CONSTANT","K_DEBUG","K_DECLARE","K_DEFAULT","K_DIAGNOSTICS",
"K_DOTDOT","K_ELSE","K_END","K_EXCEPTION","K_EXECUTE","K_EXIT","K_FOR","K_FROM",
"K_GET","K_IF","K_IN","K_INTO","K_LOOP","K_NOT","K_NOTICE","K_NULL","K_PERFORM",
"K_ROW_COUNT","K_RAISE","K_RECORD","K_RENAME","K_RESULT_OID","K_RETURN","K_REVERSE",
"K_SELECT","K_THEN","K_TO","K_TYPE","K_WHEN","K_WHILE","T_FUNCTION","T_TRIGGER",
"T_CHAR","T_BPCHAR","T_VARCHAR","T_LABEL","T_STRING","T_VARIABLE","T_ROW","T_ROWTYPE",
"T_RECORD","T_RECFIELD","T_TGARGV","T_DTYPE","T_WORD","T_NUMBER","T_ERROR","O_OPTION",
"O_DUMP","';'","'<'","'>'","'('","')'","','","pl_function","comp_optsect","comp_options",
"comp_option","pl_block","decl_sect","decl_start","decl_stmts","decl_stmt","decl_statement",
"decl_aliasitem","decl_rowtype","decl_varname","decl_renname","decl_const","decl_datatype",
"decl_dtypename","decl_atttypmod","decl_atttypmodval","decl_notnull","decl_defval",
"decl_defkey","proc_sect","proc_stmts","proc_stmt","stmt_perform","stmt_assign",
"stmt_getdiag","getdiag_list","getdiag_item","getdiag_target","assign_var","stmt_if",
"stmt_else","stmt_loop","stmt_while","stmt_fori","fori_var","fori_varname","fori_lower",
"stmt_fors","stmt_dynfors","fors_target","stmt_select","stmt_exit","stmt_return",
"stmt_raise","raise_msg","raise_level","raise_params","raise_param","loop_body",
"stmt_execsql","stmt_dynexecute","execsql_start","expr_until_semi","expr_until_then",
"expr_until_loop","opt_label","opt_exitlabel","opt_exitcond","opt_lblname","lno", NULL
};
#endif

static const short plpgsql_yyr1[] = {     0,
    66,    66,    67,    67,    68,    68,    69,    70,    71,    71,
    71,    72,    73,    73,    74,    74,    74,    75,    75,    75,
    75,    75,    76,    77,    78,    79,    80,    80,    81,    82,
    82,    82,    82,    83,    83,    84,    85,    85,    86,    86,
    87,    87,    88,    88,    89,    89,    90,    90,    90,    90,
    90,    90,    90,    90,    90,    90,    90,    90,    90,    90,
    90,    90,    91,    92,    93,    94,    94,    95,    95,    96,
    96,    97,    97,    98,    99,    99,   100,   101,   102,   103,
   104,   104,   105,   106,   107,   108,   108,   109,   110,   111,
   112,   112,   113,   114,   114,   114,   115,   115,   116,   116,
   116,   117,   118,   119,   120,   120,   121,   122,   123,   124,
   124,   125,   125,   126,   126,   127,   128
};

static const short plpgsql_yyr2[] = {     0,
     3,     3,     0,     1,     2,     1,     2,     6,     1,     2,
     3,     1,     2,     1,     5,     1,     1,     5,     3,     3,
     5,     5,     1,     1,     1,     1,     0,     1,     1,     1,
     2,     2,     4,     0,     3,     1,     0,     2,     1,     1,
     1,     1,     0,     1,     2,     1,     1,     1,     1,     1,
     1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
     1,     1,     3,     4,     5,     5,     3,     1,     1,     1,
     1,     1,     1,     8,     0,     2,     4,     5,     8,     1,
     1,     1,     0,     8,     8,     1,     1,     2,     4,     2,
     6,     5,     1,     1,     1,     1,     2,     1,     2,     2,
     2,     4,     2,     3,     1,     1,     0,     0,     0,     0,
     5,     0,     1,     1,     2,     1,     0
};

static const short plpgsql_yydefact[] = {     0,
     3,     3,     0,   110,     4,     6,   110,     7,     0,     1,
     0,     9,     5,     2,     0,   117,    12,    10,   116,     0,
   110,    16,     0,    25,     0,    11,    14,    17,    27,     0,
   117,   117,     0,   117,   117,   117,   117,   117,    72,    73,
   105,   106,    47,     0,   110,    46,    61,    48,    62,   117,
    49,    50,    51,    52,    53,    60,    54,    55,    56,    57,
    58,    59,   117,     9,    26,     0,     0,    13,     0,    28,
     0,    24,     0,     0,   111,   107,   112,   117,   108,   107,
     0,    90,    88,     0,    45,     0,   103,   117,   117,   117,
     0,     0,     0,    19,    20,    34,     0,    34,    30,    37,
    29,   104,   113,     0,     0,   110,    63,    96,    94,    95,
     0,     8,   107,     0,   110,   109,     0,     0,    23,     0,
     0,    31,     0,    32,     0,     0,   107,   114,    89,    70,
    71,     0,     0,    75,    93,     0,    64,    81,    87,    86,
    82,     0,    80,     0,     0,    77,   110,    22,    15,    21,
    36,     0,     0,    38,    41,    42,    39,    18,    40,   115,
    65,     0,     0,   110,     0,    92,     0,     0,    98,    83,
     0,     0,    78,    35,    33,     0,    68,    69,    67,    76,
     0,    99,   100,   101,    91,    97,   109,   109,   109,     0,
     0,     0,   110,   110,   110,   102,    66,    74,    79,    85,
    84,     0,     0,     0
};

static const short plpgsql_yydefgoto[] = {   202,
     4,     5,     6,    43,    11,    18,    26,    27,    28,   120,
    73,    29,    66,    74,   100,   101,   122,   152,   126,   158,
   159,   145,    45,    46,    47,    48,    49,   132,   179,   133,
    50,    51,   165,    52,    53,    54,   142,   143,   187,    55,
    56,   144,    57,    58,    59,    60,   136,   111,   168,   169,
   146,    61,    62,    63,   102,   106,   147,    64,   104,   129,
    20,    21
};

static const short plpgsql_yypact[] = {    80,
   -23,   -23,   -20,   -16,   -23,-32768,   -16,-32768,   -10,-32768,
    48,    47,-32768,-32768,    13,-32768,-32768,    -5,-32768,    14,
    90,-32768,    28,-32768,    26,    -5,-32768,-32768,    24,    35,
-32768,-32768,    94,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,   100,     9,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,    29,-32768,    71,    13,-32768,   101,-32768,
    64,-32768,    69,    46,-32768,-32768,    84,-32768,-32768,-32768,
    70,-32768,-32768,    72,-32768,   127,-32768,-32768,-32768,-32768,
    28,    73,    78,-32768,-32768,    74,    76,    74,-32768,   110,
-32768,-32768,-32768,   -29,   -37,    59,-32768,-32768,-32768,-32768,
    89,-32768,-32768,    -8,    90,-32768,    81,    82,-32768,    86,
    92,-32768,    92,-32768,   114,     5,-32768,-32768,-32768,-32768,
-32768,     2,   145,   138,-32768,    33,-32768,-32768,-32768,-32768,
-32768,   131,-32768,   132,   141,-32768,    90,-32768,-32768,-32768,
-32768,    91,    93,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,   -37,    -9,    90,   143,-32768,   -35,    36,-32768,-32768,
    -3,   135,-32768,-32768,-32768,   155,-32768,-32768,-32768,-32768,
   140,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,   102,
    -9,   103,    90,    90,    90,-32768,-32768,-32768,-32768,-32768,
-32768,   161,   164,-32768
};

static const short plpgsql_yypgoto[] = {-32768,
   163,-32768,   162,    95,-32768,-32768,-32768,   142,-32768,-32768,
-32768,-32768,    75,-32768,-32768,-32768,    77,    49,-32768,-32768,
-32768,   -21,-32768,   124,-32768,-32768,-32768,-32768,   -18,     8,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,     3,
  -113,-32768,-32768,-32768,   -64,-32768,   -61,   108,-32768,-32768,
   107,   -30
};


#define	PLPGSQL_YYLAST		175


static const short plpgsql_yytable[] = {    44,
    76,    77,    22,    79,    80,    81,    82,    83,   155,   127,
   130,   188,   182,   156,   131,   107,   183,   184,   177,    86,
   -44,   -44,   178,    31,    32,    23,    69,    33,    34,    70,
   128,   189,    87,   173,     3,    35,    17,    36,     8,   138,
   139,    37,   140,    38,     9,    88,   141,   105,   137,    24,
    15,    89,    16,    71,    17,    25,    39,   114,   115,   116,
    40,   161,   160,    41,   157,    42,   162,    19,    90,     9,
   -43,   -43,    72,    31,    32,    30,   108,    33,    34,   199,
   200,   201,    65,   109,   134,    35,    67,    36,    96,    97,
    98,    37,   166,    38,   110,   185,    75,   167,    10,    99,
   167,    14,   -43,    78,    31,    32,    39,    91,    33,    34,
    40,    12,    84,    41,    12,    42,    35,    93,    36,     9,
     1,     2,    37,    94,    38,   193,   194,   195,    95,   103,
   113,   112,   119,   125,   118,   135,   121,    39,   123,   154,
   148,    40,   180,   149,    41,   150,    42,   151,   163,   164,
     9,   170,   171,   172,   174,   181,   175,   190,   191,   192,
   203,   196,   198,   204,     7,   117,    13,    68,    85,   176,
   186,   153,   197,    92,   124
};

static const short plpgsql_yycheck[] = {    21,
    31,    32,     8,    34,    35,    36,    37,    38,     4,    39,
    48,    15,    48,     9,    52,    80,    52,    53,    28,    50,
    12,    13,    32,    15,    16,    31,     3,    19,    20,     6,
    60,    35,    63,   147,    58,    27,     8,    29,    59,    48,
    49,    33,    51,    35,    61,    17,    55,    78,   113,    55,
    61,    23,     5,    30,     8,    61,    48,    88,    89,    90,
    52,    60,   127,    55,    60,    57,    65,    55,    40,    61,
    12,    13,    49,    15,    16,    62,     7,    19,    20,   193,
   194,   195,    55,    14,   106,    27,    61,    29,    43,    44,
    45,    33,    60,    35,    25,    60,    62,    65,     4,    54,
    65,     7,    13,    10,    15,    16,    48,    37,    19,    20,
    52,     4,    13,    55,     7,    57,    27,    17,    29,    61,
    41,    42,    33,    60,    35,   187,   188,   189,    60,    46,
     4,    60,    55,    24,    62,    47,    63,    48,    63,    26,
    60,    52,   164,    62,    55,    60,    57,    56,     4,    12,
    61,    21,    21,    13,    64,    13,    64,    23,     4,    20,
     0,    60,    60,     0,     2,    91,     5,    26,    45,   162,
   168,   123,   191,    67,    98
};
/* -*-C-*-  Note some compilers choke on comments on `#line' lines.  */
#line 3 "/usr/local/share/bison.simple"
/* This file comes from bison-1.28.  */

/* Skeleton output parser for bison,
   Copyright (C) 1984, 1989, 1990 Free Software Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.  */

/* As a special exception, when this file is copied by Bison into a
   Bison output file, you may use that output file without restriction.
   This special exception was added by the Free Software Foundation
   in version 1.24 of Bison.  */

/* This is the parser code that is written into each bison parser
  when the %semantic_parser declaration is not specified in the grammar.
  It was written by Richard Stallman by simplifying the hairy parser
  used when %semantic_parser is specified.  */

#ifndef PLPGSQL_YYSTACK_USE_ALLOCA
#ifdef alloca
#define PLPGSQL_YYSTACK_USE_ALLOCA
#else /* alloca not defined */
#ifdef __GNUC__
#define PLPGSQL_YYSTACK_USE_ALLOCA
#define alloca __builtin_alloca
#else /* not GNU C.  */
#if (!defined (__STDC__) && defined (sparc)) || defined (__sparc__) || defined (__sparc) || defined (__sgi) || (defined (__sun) && defined (__i386))
#define PLPGSQL_YYSTACK_USE_ALLOCA
#include <alloca.h>
#else /* not sparc */
/* We think this test detects Watcom and Microsoft C.  */
/* This used to test MSDOS, but that is a bad idea
   since that symbol is in the user namespace.  */
#if (defined (_MSDOS) || defined (_MSDOS_)) && !defined (__TURBOC__)
#if 0 /* No need for malloc.h, which pollutes the namespace;
	 instead, just don't use alloca.  */
#include <malloc.h>
#endif
#else /* not MSDOS, or __TURBOC__ */
#if defined(_AIX)
/* I don't know what this was needed for, but it pollutes the namespace.
   So I turned it off.   rms, 2 May 1997.  */
/* #include <malloc.h>  */
 #pragma alloca
#define PLPGSQL_YYSTACK_USE_ALLOCA
#else /* not MSDOS, or __TURBOC__, or _AIX */
#if 0
#ifdef __hpux /* haible@ilog.fr says this works for HPUX 9.05 and up,
		 and on HPUX 10.  Eventually we can turn this on.  */
#define PLPGSQL_YYSTACK_USE_ALLOCA
#define alloca __builtin_alloca
#endif /* __hpux */
#endif
#endif /* not _AIX */
#endif /* not MSDOS, or __TURBOC__ */
#endif /* not sparc */
#endif /* not GNU C */
#endif /* alloca not defined */
#endif /* PLPGSQL_YYSTACK_USE_ALLOCA not defined */

#ifdef PLPGSQL_YYSTACK_USE_ALLOCA
#define PLPGSQL_YYSTACK_ALLOC alloca
#else
#define PLPGSQL_YYSTACK_ALLOC malloc
#endif

/* Note: there must be only one dollar sign in this file.
   It is replaced by the list of actions, each action
   as one case of the switch.  */

#define plpgsql_yyerrok		(plpgsql_yyerrstatus = 0)
#define plpgsql_yyclearin	(plpgsql_yychar = PLPGSQL_YYEMPTY)
#define PLPGSQL_YYEMPTY		-2
#define PLPGSQL_YYEOF		0
#define PLPGSQL_YYACCEPT	goto plpgsql_yyacceptlab
#define PLPGSQL_YYABORT 	goto plpgsql_yyabortlab
#define PLPGSQL_YYERROR		goto plpgsql_yyerrlab1
/* Like PLPGSQL_YYERROR except do call plpgsql_yyerror.
   This remains here temporarily to ease the
   transition to the new meaning of PLPGSQL_YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */
#define PLPGSQL_YYFAIL		goto plpgsql_yyerrlab
#define PLPGSQL_YYRECOVERING()  (!!plpgsql_yyerrstatus)
#define PLPGSQL_YYBACKUP(token, value) \
do								\
  if (plpgsql_yychar == PLPGSQL_YYEMPTY && plpgsql_yylen == 1)				\
    { plpgsql_yychar = (token), plpgsql_yylval = (value);			\
      plpgsql_yychar1 = PLPGSQL_YYTRANSLATE (plpgsql_yychar);				\
      PLPGSQL_YYPOPSTACK;						\
      goto plpgsql_yybackup;						\
    }								\
  else								\
    { plpgsql_yyerror ("syntax error: cannot back up"); PLPGSQL_YYERROR; }	\
while (0)

#define PLPGSQL_YYTERROR	1
#define PLPGSQL_YYERRCODE	256

#ifndef PLPGSQL_YYPURE
#define PLPGSQL_YYLEX		plpgsql_yylex()
#endif

#ifdef PLPGSQL_YYPURE
#ifdef PLPGSQL_YYLSP_NEEDED
#ifdef PLPGSQL_YYLEX_PARAM
#define PLPGSQL_YYLEX		plpgsql_yylex(&plpgsql_yylval, &plpgsql_yylloc, PLPGSQL_YYLEX_PARAM)
#else
#define PLPGSQL_YYLEX		plpgsql_yylex(&plpgsql_yylval, &plpgsql_yylloc)
#endif
#else /* not PLPGSQL_YYLSP_NEEDED */
#ifdef PLPGSQL_YYLEX_PARAM
#define PLPGSQL_YYLEX		plpgsql_yylex(&plpgsql_yylval, PLPGSQL_YYLEX_PARAM)
#else
#define PLPGSQL_YYLEX		plpgsql_yylex(&plpgsql_yylval)
#endif
#endif /* not PLPGSQL_YYLSP_NEEDED */
#endif

/* If nonreentrant, generate the variables here */

#ifndef PLPGSQL_YYPURE

int	plpgsql_yychar;			/*  the lookahead symbol		*/
PLPGSQL_YYSTYPE	plpgsql_yylval;			/*  the semantic value of the		*/
				/*  lookahead symbol			*/

#ifdef PLPGSQL_YYLSP_NEEDED
PLPGSQL_YYLTYPE plpgsql_yylloc;			/*  location data for the lookahead	*/
				/*  symbol				*/
#endif

int plpgsql_yynerrs;			/*  number of parse errors so far       */
#endif  /* not PLPGSQL_YYPURE */

#if PLPGSQL_YYDEBUG != 0
int plpgsql_yydebug;			/*  nonzero means print parse trace	*/
/* Since this is uninitialized, it does not stop multiple parsers
   from coexisting.  */
#endif

/*  PLPGSQL_YYINITDEPTH indicates the initial size of the parser's stacks	*/

#ifndef	PLPGSQL_YYINITDEPTH
#define PLPGSQL_YYINITDEPTH 200
#endif

/*  PLPGSQL_YYMAXDEPTH is the maximum size the stacks can grow to
    (effective only if the built-in stack extension method is used).  */

#if PLPGSQL_YYMAXDEPTH == 0
#undef PLPGSQL_YYMAXDEPTH
#endif

#ifndef PLPGSQL_YYMAXDEPTH
#define PLPGSQL_YYMAXDEPTH 10000
#endif

/* Define __plpgsql_yy_memcpy.  Note that the size argument
   should be passed with type unsigned int, because that is what the non-GCC
   definitions require.  With GCC, __builtin_memcpy takes an arg
   of type size_t, but it can handle unsigned int.  */

#if __GNUC__ > 1		/* GNU C and GNU C++ define this.  */
#define __plpgsql_yy_memcpy(TO,FROM,COUNT)	__builtin_memcpy(TO,FROM,COUNT)
#else				/* not GNU C or C++ */
#ifndef __cplusplus

/* This is the most reliable way to avoid incompatibilities
   in available built-in functions on various systems.  */
static void
__plpgsql_yy_memcpy (to, from, count)
     char *to;
     char *from;
     unsigned int count;
{
  register char *f = from;
  register char *t = to;
  register int i = count;

  while (i-- > 0)
    *t++ = *f++;
}

#else /* __cplusplus */

/* This is the most reliable way to avoid incompatibilities
   in available built-in functions on various systems.  */
static void
__plpgsql_yy_memcpy (char *to, char *from, unsigned int count)
{
  register char *t = to;
  register char *f = from;
  register int i = count;

  while (i-- > 0)
    *t++ = *f++;
}

#endif
#endif

#line 217 "/usr/local/share/bison.simple"

/* The user can define PLPGSQL_YYPARSE_PARAM as the name of an argument to be passed
   into plpgsql_yyparse.  The argument should have type void *.
   It should actually point to an object.
   Grammar actions can access the variable by casting it
   to the proper pointer type.  */

#ifdef PLPGSQL_YYPARSE_PARAM
#ifdef __cplusplus
#define PLPGSQL_YYPARSE_PARAM_ARG void *PLPGSQL_YYPARSE_PARAM
#define PLPGSQL_YYPARSE_PARAM_DECL
#else /* not __cplusplus */
#define PLPGSQL_YYPARSE_PARAM_ARG PLPGSQL_YYPARSE_PARAM
#define PLPGSQL_YYPARSE_PARAM_DECL void *PLPGSQL_YYPARSE_PARAM;
#endif /* not __cplusplus */
#else /* not PLPGSQL_YYPARSE_PARAM */
#define PLPGSQL_YYPARSE_PARAM_ARG
#define PLPGSQL_YYPARSE_PARAM_DECL
#endif /* not PLPGSQL_YYPARSE_PARAM */

/* Prevent warning if -Wstrict-prototypes.  */
#ifdef __GNUC__
#ifdef PLPGSQL_YYPARSE_PARAM
int plpgsql_yyparse (void *);
#else
int plpgsql_yyparse (void);
#endif
#endif

int
plpgsql_yyparse(PLPGSQL_YYPARSE_PARAM_ARG)
     PLPGSQL_YYPARSE_PARAM_DECL
{
  register int plpgsql_yystate;
  register int plpgsql_yyn;
  register short *plpgsql_yyssp;
  register PLPGSQL_YYSTYPE *plpgsql_yyvsp;
  int plpgsql_yyerrstatus;	/*  number of tokens to shift before error messages enabled */
  int plpgsql_yychar1 = 0;		/*  lookahead token as an internal (translated) token number */

  short	plpgsql_yyssa[PLPGSQL_YYINITDEPTH];	/*  the state stack			*/
  PLPGSQL_YYSTYPE plpgsql_yyvsa[PLPGSQL_YYINITDEPTH];	/*  the semantic value stack		*/

  short *plpgsql_yyss = plpgsql_yyssa;		/*  refer to the stacks thru separate pointers */
  PLPGSQL_YYSTYPE *plpgsql_yyvs = plpgsql_yyvsa;	/*  to allow plpgsql_yyoverflow to reallocate them elsewhere */

#ifdef PLPGSQL_YYLSP_NEEDED
  PLPGSQL_YYLTYPE plpgsql_yylsa[PLPGSQL_YYINITDEPTH];	/*  the location stack			*/
  PLPGSQL_YYLTYPE *plpgsql_yyls = plpgsql_yylsa;
  PLPGSQL_YYLTYPE *plpgsql_yylsp;

#define PLPGSQL_YYPOPSTACK   (plpgsql_yyvsp--, plpgsql_yyssp--, plpgsql_yylsp--)
#else
#define PLPGSQL_YYPOPSTACK   (plpgsql_yyvsp--, plpgsql_yyssp--)
#endif

  int plpgsql_yystacksize = PLPGSQL_YYINITDEPTH;
  int plpgsql_yyfree_stacks = 0;

#ifdef PLPGSQL_YYPURE
  int plpgsql_yychar;
  PLPGSQL_YYSTYPE plpgsql_yylval;
  int plpgsql_yynerrs;
#ifdef PLPGSQL_YYLSP_NEEDED
  PLPGSQL_YYLTYPE plpgsql_yylloc;
#endif
#endif

  PLPGSQL_YYSTYPE plpgsql_yyval;		/*  the variable used to return		*/
				/*  semantic values from the action	*/
				/*  routines				*/

  int plpgsql_yylen;

#if PLPGSQL_YYDEBUG != 0
  if (plpgsql_yydebug)
    fprintf(stderr, "Starting parse\n");
#endif

  plpgsql_yystate = 0;
  plpgsql_yyerrstatus = 0;
  plpgsql_yynerrs = 0;
  plpgsql_yychar = PLPGSQL_YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  plpgsql_yyssp = plpgsql_yyss - 1;
  plpgsql_yyvsp = plpgsql_yyvs;
#ifdef PLPGSQL_YYLSP_NEEDED
  plpgsql_yylsp = plpgsql_yyls;
#endif

/* Push a new state, which is found in  plpgsql_yystate  .  */
/* In all cases, when you get here, the value and location stacks
   have just been pushed. so pushing a state here evens the stacks.  */
plpgsql_yynewstate:

  *++plpgsql_yyssp = plpgsql_yystate;

  if (plpgsql_yyssp >= plpgsql_yyss + plpgsql_yystacksize - 1)
    {
      /* Give user a chance to reallocate the stack */
      /* Use copies of these so that the &'s don't force the real ones into memory. */
      PLPGSQL_YYSTYPE *plpgsql_yyvs1 = plpgsql_yyvs;
      short *plpgsql_yyss1 = plpgsql_yyss;
#ifdef PLPGSQL_YYLSP_NEEDED
      PLPGSQL_YYLTYPE *plpgsql_yyls1 = plpgsql_yyls;
#endif

      /* Get the current used size of the three stacks, in elements.  */
      int size = plpgsql_yyssp - plpgsql_yyss + 1;

#ifdef plpgsql_yyoverflow
      /* Each stack pointer address is followed by the size of
	 the data in use in that stack, in bytes.  */
#ifdef PLPGSQL_YYLSP_NEEDED
      /* This used to be a conditional around just the two extra args,
	 but that might be undefined if plpgsql_yyoverflow is a macro.  */
      plpgsql_yyoverflow("parser stack overflow",
		 &plpgsql_yyss1, size * sizeof (*plpgsql_yyssp),
		 &plpgsql_yyvs1, size * sizeof (*plpgsql_yyvsp),
		 &plpgsql_yyls1, size * sizeof (*plpgsql_yylsp),
		 &plpgsql_yystacksize);
#else
      plpgsql_yyoverflow("parser stack overflow",
		 &plpgsql_yyss1, size * sizeof (*plpgsql_yyssp),
		 &plpgsql_yyvs1, size * sizeof (*plpgsql_yyvsp),
		 &plpgsql_yystacksize);
#endif

      plpgsql_yyss = plpgsql_yyss1; plpgsql_yyvs = plpgsql_yyvs1;
#ifdef PLPGSQL_YYLSP_NEEDED
      plpgsql_yyls = plpgsql_yyls1;
#endif
#else /* no plpgsql_yyoverflow */
      /* Extend the stack our own way.  */
      if (plpgsql_yystacksize >= PLPGSQL_YYMAXDEPTH)
	{
	  plpgsql_yyerror("parser stack overflow");
	  if (plpgsql_yyfree_stacks)
	    {
	      free (plpgsql_yyss);
	      free (plpgsql_yyvs);
#ifdef PLPGSQL_YYLSP_NEEDED
	      free (plpgsql_yyls);
#endif
	    }
	  return 2;
	}
      plpgsql_yystacksize *= 2;
      if (plpgsql_yystacksize > PLPGSQL_YYMAXDEPTH)
	plpgsql_yystacksize = PLPGSQL_YYMAXDEPTH;
#ifndef PLPGSQL_YYSTACK_USE_ALLOCA
      plpgsql_yyfree_stacks = 1;
#endif
      plpgsql_yyss = (short *) PLPGSQL_YYSTACK_ALLOC (plpgsql_yystacksize * sizeof (*plpgsql_yyssp));
      __plpgsql_yy_memcpy ((char *)plpgsql_yyss, (char *)plpgsql_yyss1,
		   size * (unsigned int) sizeof (*plpgsql_yyssp));
      plpgsql_yyvs = (PLPGSQL_YYSTYPE *) PLPGSQL_YYSTACK_ALLOC (plpgsql_yystacksize * sizeof (*plpgsql_yyvsp));
      __plpgsql_yy_memcpy ((char *)plpgsql_yyvs, (char *)plpgsql_yyvs1,
		   size * (unsigned int) sizeof (*plpgsql_yyvsp));
#ifdef PLPGSQL_YYLSP_NEEDED
      plpgsql_yyls = (PLPGSQL_YYLTYPE *) PLPGSQL_YYSTACK_ALLOC (plpgsql_yystacksize * sizeof (*plpgsql_yylsp));
      __plpgsql_yy_memcpy ((char *)plpgsql_yyls, (char *)plpgsql_yyls1,
		   size * (unsigned int) sizeof (*plpgsql_yylsp));
#endif
#endif /* no plpgsql_yyoverflow */

      plpgsql_yyssp = plpgsql_yyss + size - 1;
      plpgsql_yyvsp = plpgsql_yyvs + size - 1;
#ifdef PLPGSQL_YYLSP_NEEDED
      plpgsql_yylsp = plpgsql_yyls + size - 1;
#endif

#if PLPGSQL_YYDEBUG != 0
      if (plpgsql_yydebug)
	fprintf(stderr, "Stack size increased to %d\n", plpgsql_yystacksize);
#endif

      if (plpgsql_yyssp >= plpgsql_yyss + plpgsql_yystacksize - 1)
	PLPGSQL_YYABORT;
    }

#if PLPGSQL_YYDEBUG != 0
  if (plpgsql_yydebug)
    fprintf(stderr, "Entering state %d\n", plpgsql_yystate);
#endif

  goto plpgsql_yybackup;
 plpgsql_yybackup:

/* Do appropriate processing given the current state.  */
/* Read a lookahead token if we need one and don't already have one.  */
/* plpgsql_yyresume: */

  /* First try to decide what to do without reference to lookahead token.  */

  plpgsql_yyn = plpgsql_yypact[plpgsql_yystate];
  if (plpgsql_yyn == PLPGSQL_YYFLAG)
    goto plpgsql_yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* plpgsql_yychar is either PLPGSQL_YYEMPTY or PLPGSQL_YYEOF
     or a valid token in external form.  */

  if (plpgsql_yychar == PLPGSQL_YYEMPTY)
    {
#if PLPGSQL_YYDEBUG != 0
      if (plpgsql_yydebug)
	fprintf(stderr, "Reading a token: ");
#endif
      plpgsql_yychar = PLPGSQL_YYLEX;
    }

  /* Convert token to internal form (in plpgsql_yychar1) for indexing tables with */

  if (plpgsql_yychar <= 0)		/* This means end of input. */
    {
      plpgsql_yychar1 = 0;
      plpgsql_yychar = PLPGSQL_YYEOF;		/* Don't call PLPGSQL_YYLEX any more */

#if PLPGSQL_YYDEBUG != 0
      if (plpgsql_yydebug)
	fprintf(stderr, "Now at end of input.\n");
#endif
    }
  else
    {
      plpgsql_yychar1 = PLPGSQL_YYTRANSLATE(plpgsql_yychar);

#if PLPGSQL_YYDEBUG != 0
      if (plpgsql_yydebug)
	{
	  fprintf (stderr, "Next token is %d (%s", plpgsql_yychar, plpgsql_yytname[plpgsql_yychar1]);
	  /* Give the individual parser a way to print the precise meaning
	     of a token, for further debugging info.  */
#ifdef PLPGSQL_YYPRINT
	  PLPGSQL_YYPRINT (stderr, plpgsql_yychar, plpgsql_yylval);
#endif
	  fprintf (stderr, ")\n");
	}
#endif
    }

  plpgsql_yyn += plpgsql_yychar1;
  if (plpgsql_yyn < 0 || plpgsql_yyn > PLPGSQL_YYLAST || plpgsql_yycheck[plpgsql_yyn] != plpgsql_yychar1)
    goto plpgsql_yydefault;

  plpgsql_yyn = plpgsql_yytable[plpgsql_yyn];

  /* plpgsql_yyn is what to do for this token type in this state.
     Negative => reduce, -plpgsql_yyn is rule number.
     Positive => shift, plpgsql_yyn is new state.
       New state is final state => don't bother to shift,
       just return success.
     0, or most negative number => error.  */

  if (plpgsql_yyn < 0)
    {
      if (plpgsql_yyn == PLPGSQL_YYFLAG)
	goto plpgsql_yyerrlab;
      plpgsql_yyn = -plpgsql_yyn;
      goto plpgsql_yyreduce;
    }
  else if (plpgsql_yyn == 0)
    goto plpgsql_yyerrlab;

  if (plpgsql_yyn == PLPGSQL_YYFINAL)
    PLPGSQL_YYACCEPT;

  /* Shift the lookahead token.  */

#if PLPGSQL_YYDEBUG != 0
  if (plpgsql_yydebug)
    fprintf(stderr, "Shifting token %d (%s), ", plpgsql_yychar, plpgsql_yytname[plpgsql_yychar1]);
#endif

  /* Discard the token being shifted unless it is eof.  */
  if (plpgsql_yychar != PLPGSQL_YYEOF)
    plpgsql_yychar = PLPGSQL_YYEMPTY;

  *++plpgsql_yyvsp = plpgsql_yylval;
#ifdef PLPGSQL_YYLSP_NEEDED
  *++plpgsql_yylsp = plpgsql_yylloc;
#endif

  /* count tokens shifted since error; after three, turn off error status.  */
  if (plpgsql_yyerrstatus) plpgsql_yyerrstatus--;

  plpgsql_yystate = plpgsql_yyn;
  goto plpgsql_yynewstate;

/* Do the default action for the current state.  */
plpgsql_yydefault:

  plpgsql_yyn = plpgsql_yydefact[plpgsql_yystate];
  if (plpgsql_yyn == 0)
    goto plpgsql_yyerrlab;

/* Do a reduction.  plpgsql_yyn is the number of a rule to reduce with.  */
plpgsql_yyreduce:
  plpgsql_yylen = plpgsql_yyr2[plpgsql_yyn];
  if (plpgsql_yylen > 0)
    plpgsql_yyval = plpgsql_yyvsp[1-plpgsql_yylen]; /* implement default value of the action */

#if PLPGSQL_YYDEBUG != 0
  if (plpgsql_yydebug)
    {
      int i;

      fprintf (stderr, "Reducing via rule %d (line %d), ",
	       plpgsql_yyn, plpgsql_yyrline[plpgsql_yyn]);

      /* Print the symbols being reduced, and their result.  */
      for (i = plpgsql_yyprhs[plpgsql_yyn]; plpgsql_yyrhs[i] > 0; i++)
	fprintf (stderr, "%s ", plpgsql_yytname[plpgsql_yyrhs[i]]);
      fprintf (stderr, " -> %s\n", plpgsql_yytname[plpgsql_yyr1[plpgsql_yyn]]);
    }
#endif


  switch (plpgsql_yyn) {

case 1:
#line 206 "gram.y"
{
						plpgsql_yylval.program = (PLpgSQL_stmt_block *)plpgsql_yyvsp[0].stmt;
					;
    break;}
case 2:
#line 210 "gram.y"
{
						plpgsql_yylval.program = (PLpgSQL_stmt_block *)plpgsql_yyvsp[0].stmt;
					;
    break;}
case 7:
#line 224 "gram.y"
{
						plpgsql_DumpExecTree = 1;
					;
    break;}
case 8:
#line 230 "gram.y"
{
						PLpgSQL_stmt_block *new;

						new = malloc(sizeof(PLpgSQL_stmt_block));
						memset(new, 0, sizeof(PLpgSQL_stmt_block));

						new->cmd_type	= PLPGSQL_STMT_BLOCK;
						new->lineno		= plpgsql_yyvsp[-3].ival;
						new->label		= plpgsql_yyvsp[-5].declhdr.label;
						new->n_initvars = plpgsql_yyvsp[-5].declhdr.n_initvars;
						new->initvarnos = plpgsql_yyvsp[-5].declhdr.initvarnos;
						new->body		= plpgsql_yyvsp[-2].stmts;

						plpgsql_ns_pop();

						plpgsql_yyval.stmt = (PLpgSQL_stmt *)new;
					;
    break;}
case 9:
#line 251 "gram.y"
{
						plpgsql_ns_setlocal(false);
						plpgsql_yyval.declhdr.label	  = plpgsql_yyvsp[0].str;
						plpgsql_yyval.declhdr.n_initvars = 0;
						plpgsql_yyval.declhdr.initvarnos = NULL;
						plpgsql_add_initdatums(NULL);
					;
    break;}
case 10:
#line 259 "gram.y"
{
						plpgsql_ns_setlocal(false);
						plpgsql_yyval.declhdr.label	  = plpgsql_yyvsp[-1].str;
						plpgsql_yyval.declhdr.n_initvars = 0;
						plpgsql_yyval.declhdr.initvarnos = NULL;
						plpgsql_add_initdatums(NULL);
					;
    break;}
case 11:
#line 267 "gram.y"
{
						plpgsql_ns_setlocal(false);
						if (plpgsql_yyvsp[0].str != NULL)
							plpgsql_yyval.declhdr.label = plpgsql_yyvsp[0].str;
						else
							plpgsql_yyval.declhdr.label = plpgsql_yyvsp[-2].str;
						plpgsql_yyval.declhdr.n_initvars = plpgsql_add_initdatums(&(plpgsql_yyval.declhdr.initvarnos));
					;
    break;}
case 12:
#line 278 "gram.y"
{
						plpgsql_ns_setlocal(true);
					;
    break;}
case 13:
#line 284 "gram.y"
{	plpgsql_yyval.str = plpgsql_yyvsp[0].str;	;
    break;}
case 14:
#line 286 "gram.y"
{	plpgsql_yyval.str = plpgsql_yyvsp[0].str;	;
    break;}
case 15:
#line 290 "gram.y"
{	plpgsql_yyval.str = plpgsql_yyvsp[-2].str;	;
    break;}
case 16:
#line 292 "gram.y"
{	plpgsql_yyval.str = NULL;	;
    break;}
case 17:
#line 294 "gram.y"
{	plpgsql_yyval.str = NULL;	;
    break;}
case 18:
#line 298 "gram.y"
{
						PLpgSQL_var		*new;

						new = malloc(sizeof(PLpgSQL_var));

						new->dtype		= PLPGSQL_DTYPE_VAR;
						new->refname	= plpgsql_yyvsp[-4].varname.name;
						new->lineno		= plpgsql_yyvsp[-4].varname.lineno;

						new->datatype	= plpgsql_yyvsp[-2].dtype;
						new->isconst	= plpgsql_yyvsp[-3].ival;
						new->notnull	= plpgsql_yyvsp[-1].ival;
						new->default_val = plpgsql_yyvsp[0].expr;

						plpgsql_adddatum((PLpgSQL_datum *)new);
						plpgsql_ns_additem(PLPGSQL_NSTYPE_VAR, new->varno,
												plpgsql_yyvsp[-4].varname.name);
					;
    break;}
case 19:
#line 317 "gram.y"
{
						PLpgSQL_rec		*new;

						new = malloc(sizeof(PLpgSQL_var));

						new->dtype		= PLPGSQL_DTYPE_REC;
						new->refname	= plpgsql_yyvsp[-2].varname.name;
						new->lineno		= plpgsql_yyvsp[-2].varname.lineno;

						plpgsql_adddatum((PLpgSQL_datum *)new);
						plpgsql_ns_additem(PLPGSQL_NSTYPE_REC, new->recno,
												plpgsql_yyvsp[-2].varname.name);
					;
    break;}
case 20:
#line 331 "gram.y"
{
						plpgsql_yyvsp[-1].row->dtype		= PLPGSQL_DTYPE_ROW;
						plpgsql_yyvsp[-1].row->refname		= plpgsql_yyvsp[-2].varname.name;
						plpgsql_yyvsp[-1].row->lineno		= plpgsql_yyvsp[-2].varname.lineno;

						plpgsql_adddatum((PLpgSQL_datum *)plpgsql_yyvsp[-1].row);
						plpgsql_ns_additem(PLPGSQL_NSTYPE_ROW, plpgsql_yyvsp[-1].row->rowno,
												plpgsql_yyvsp[-2].varname.name);
					;
    break;}
case 21:
#line 341 "gram.y"
{
						plpgsql_ns_additem(plpgsql_yyvsp[-1].nsitem->itemtype,
										plpgsql_yyvsp[-1].nsitem->itemno, plpgsql_yyvsp[-4].varname.name);
					;
    break;}
case 22:
#line 346 "gram.y"
{
						plpgsql_ns_rename(plpgsql_yyvsp[-3].str, plpgsql_yyvsp[-1].str);
					;
    break;}
case 23:
#line 352 "gram.y"
{
						PLpgSQL_nsitem *nsi;
						char	*name;

						plpgsql_ns_setlocal(false);
						name = plpgsql_tolower(plpgsql_yytext);
						if (name[0] != '$')
							elog(ERROR, "can only alias positional parameters");
						nsi = plpgsql_ns_lookup(name, NULL);
						if (nsi == NULL)
							elog(ERROR, "function has no parameter %s", name);

						plpgsql_ns_setlocal(true);

						plpgsql_yyval.nsitem = nsi;
					;
    break;}
case 24:
#line 371 "gram.y"
{
						plpgsql_yyval.row = plpgsql_yylval.row;
					;
    break;}
case 25:
#line 377 "gram.y"
{
						/* name should be malloc'd for use as varname */
						plpgsql_yyval.varname.name = strdup(plpgsql_tolower(plpgsql_yytext));
						plpgsql_yyval.varname.lineno  = plpgsql_yylineno;
					;
    break;}
case 26:
#line 385 "gram.y"
{
						/* the result must be palloc'd, see plpgsql_ns_rename */
						plpgsql_yyval.str = plpgsql_tolower(plpgsql_yytext);
					;
    break;}
case 27:
#line 392 "gram.y"
{ plpgsql_yyval.ival = 0; ;
    break;}
case 28:
#line 394 "gram.y"
{ plpgsql_yyval.ival = 1; ;
    break;}
case 29:
#line 398 "gram.y"
{ plpgsql_yyval.dtype = plpgsql_yyvsp[0].dtype; ;
    break;}
case 30:
#line 402 "gram.y"
{ plpgsql_yyval.dtype = plpgsql_yylval.dtype; ;
    break;}
case 31:
#line 404 "gram.y"
{
						if (plpgsql_yyvsp[0].ival < 0)
						{
							plpgsql_parse_word("char");
							plpgsql_yyval.dtype = plpgsql_yylval.dtype;
						} else
						{
							plpgsql_parse_word("bpchar");
							plpgsql_yyval.dtype = plpgsql_yylval.dtype;
							plpgsql_yyval.dtype->atttypmod = plpgsql_yyvsp[0].ival;
						}
					;
    break;}
case 32:
#line 417 "gram.y"
{
						plpgsql_parse_word("varchar");
						plpgsql_yyval.dtype = plpgsql_yylval.dtype;
						plpgsql_yyval.dtype->atttypmod = plpgsql_yyvsp[0].ival;
					;
    break;}
case 33:
#line 423 "gram.y"
{
						plpgsql_parse_word("bpchar");
						plpgsql_yyval.dtype = plpgsql_yylval.dtype;
						plpgsql_yyval.dtype->atttypmod = plpgsql_yyvsp[-1].ival;
					;
    break;}
case 34:
#line 431 "gram.y"
{ plpgsql_yyval.ival = -1; ;
    break;}
case 35:
#line 433 "gram.y"
{ plpgsql_yyval.ival = plpgsql_yyvsp[-1].ival; ;
    break;}
case 36:
#line 437 "gram.y"
{
						plpgsql_yyval.ival = pg_atoi(plpgsql_yytext, sizeof(int16), '\0') + VARHDRSZ;
					;
    break;}
case 37:
#line 443 "gram.y"
{ plpgsql_yyval.ival = 0; ;
    break;}
case 38:
#line 445 "gram.y"
{ plpgsql_yyval.ival = 1; ;
    break;}
case 39:
#line 449 "gram.y"
{ plpgsql_yyval.expr = NULL; ;
    break;}
case 40:
#line 451 "gram.y"
{
						int				tok;
						int				lno;
						PLpgSQL_dstring ds;
						PLpgSQL_expr	*expr;

						lno = plpgsql_yylineno;
						expr = malloc(sizeof(PLpgSQL_expr));
						plpgsql_dstring_init(&ds);
						plpgsql_dstring_append(&ds, "SELECT ");

						expr->dtype   = PLPGSQL_DTYPE_EXPR;
						expr->plan	  = NULL;
						expr->nparams = 0;

						tok = plpgsql_yylex();
						switch (tok)
						{
							case 0:
								plpgsql_error_lineno = lno;
								plpgsql_comperrinfo();
								elog(ERROR, "unexpected end of file");
							case K_NULL:
								if (plpgsql_yylex() != ';')
								{
									plpgsql_error_lineno = lno;
									plpgsql_comperrinfo();
									elog(ERROR, "expectec ; after NULL");
								}
								free(expr);
								plpgsql_dstring_free(&ds);

								plpgsql_yyval.expr = NULL;
								break;

							default:
								plpgsql_dstring_append(&ds, plpgsql_yytext);
								while ((tok = plpgsql_yylex()) != ';')
								{
									if (tok == 0)
									{
										plpgsql_error_lineno = lno;
										plpgsql_comperrinfo();
										elog(ERROR, "unterminated default value");
									}
									if (plpgsql_SpaceScanned)
										plpgsql_dstring_append(&ds, " ");
									plpgsql_dstring_append(&ds, plpgsql_yytext);
								}
								expr->query = strdup(plpgsql_dstring_get(&ds));
								plpgsql_dstring_free(&ds);

								plpgsql_yyval.expr = expr;
								break;
						}
					;
    break;}
case 43:
#line 513 "gram.y"
{
							PLpgSQL_stmts	*new;

							new = malloc(sizeof(PLpgSQL_stmts));
							memset(new, 0, sizeof(PLpgSQL_stmts));
							plpgsql_yyval.stmts = new;
					;
    break;}
case 44:
#line 521 "gram.y"
{ plpgsql_yyval.stmts = plpgsql_yyvsp[0].stmts; ;
    break;}
case 45:
#line 525 "gram.y"
{
								if (plpgsql_yyvsp[-1].stmts->stmts_used == plpgsql_yyvsp[-1].stmts->stmts_alloc) {
									plpgsql_yyvsp[-1].stmts->stmts_alloc *= 2;
									plpgsql_yyvsp[-1].stmts->stmts = realloc(plpgsql_yyvsp[-1].stmts->stmts, sizeof(PLpgSQL_stmt *) * plpgsql_yyvsp[-1].stmts->stmts_alloc);
								}
								plpgsql_yyvsp[-1].stmts->stmts[plpgsql_yyvsp[-1].stmts->stmts_used++] = (struct PLpgSQL_stmt *)plpgsql_yyvsp[0].stmt;

								plpgsql_yyval.stmts = plpgsql_yyvsp[-1].stmts;
						;
    break;}
case 46:
#line 535 "gram.y"
{
								PLpgSQL_stmts	*new;

								new = malloc(sizeof(PLpgSQL_stmts));
								memset(new, 0, sizeof(PLpgSQL_stmts));

								new->stmts_alloc = 64;
								new->stmts_used  = 1;
								new->stmts = malloc(sizeof(PLpgSQL_stmt *) * new->stmts_alloc);
								new->stmts[0] = (struct PLpgSQL_stmt *)plpgsql_yyvsp[0].stmt;

								plpgsql_yyval.stmts = new;
						;
    break;}
case 47:
#line 551 "gram.y"
{ plpgsql_yyval.stmt = plpgsql_yyvsp[0].stmt; ;
    break;}
case 48:
#line 553 "gram.y"
{ plpgsql_yyval.stmt = plpgsql_yyvsp[0].stmt; ;
    break;}
case 49:
#line 555 "gram.y"
{ plpgsql_yyval.stmt = plpgsql_yyvsp[0].stmt; ;
    break;}
case 50:
#line 557 "gram.y"
{ plpgsql_yyval.stmt = plpgsql_yyvsp[0].stmt; ;
    break;}
case 51:
#line 559 "gram.y"
{ plpgsql_yyval.stmt = plpgsql_yyvsp[0].stmt; ;
    break;}
case 52:
#line 561 "gram.y"
{ plpgsql_yyval.stmt = plpgsql_yyvsp[0].stmt; ;
    break;}
case 53:
#line 563 "gram.y"
{ plpgsql_yyval.stmt = plpgsql_yyvsp[0].stmt; ;
    break;}
case 54:
#line 565 "gram.y"
{ plpgsql_yyval.stmt = plpgsql_yyvsp[0].stmt; ;
    break;}
case 55:
#line 567 "gram.y"
{ plpgsql_yyval.stmt = plpgsql_yyvsp[0].stmt; ;
    break;}
case 56:
#line 569 "gram.y"
{ plpgsql_yyval.stmt = plpgsql_yyvsp[0].stmt; ;
    break;}
case 57:
#line 571 "gram.y"
{ plpgsql_yyval.stmt = plpgsql_yyvsp[0].stmt; ;
    break;}
case 58:
#line 573 "gram.y"
{ plpgsql_yyval.stmt = plpgsql_yyvsp[0].stmt; ;
    break;}
case 59:
#line 575 "gram.y"
{ plpgsql_yyval.stmt = plpgsql_yyvsp[0].stmt; ;
    break;}
case 60:
#line 577 "gram.y"
{ plpgsql_yyval.stmt = plpgsql_yyvsp[0].stmt; ;
    break;}
case 61:
#line 579 "gram.y"
{ plpgsql_yyval.stmt = plpgsql_yyvsp[0].stmt; ;
    break;}
case 62:
#line 581 "gram.y"
{ plpgsql_yyval.stmt = plpgsql_yyvsp[0].stmt; ;
    break;}
case 63:
#line 585 "gram.y"
{
						PLpgSQL_stmt_assign *new;

						new = malloc(sizeof(PLpgSQL_stmt_assign));
						memset(new, 0, sizeof(PLpgSQL_stmt_assign));

						new->cmd_type = PLPGSQL_STMT_ASSIGN;
						new->lineno   = plpgsql_yyvsp[-1].ival;
						new->varno = -1;
						new->expr  = plpgsql_yyvsp[0].expr;

						plpgsql_yyval.stmt = (PLpgSQL_stmt *)new;
					;
    break;}
case 64:
#line 601 "gram.y"
{
						PLpgSQL_stmt_assign *new;

						new = malloc(sizeof(PLpgSQL_stmt_assign));
						memset(new, 0, sizeof(PLpgSQL_stmt_assign));

						new->cmd_type = PLPGSQL_STMT_ASSIGN;
						new->lineno   = plpgsql_yyvsp[-2].ival;
						new->varno = plpgsql_yyvsp[-3].ival;
						new->expr  = plpgsql_yyvsp[0].expr;

						plpgsql_yyval.stmt = (PLpgSQL_stmt *)new;
					;
    break;}
case 65:
#line 617 "gram.y"
{
						PLpgSQL_stmt_getdiag	 *new;

						new = malloc(sizeof(PLpgSQL_stmt_getdiag));
						memset(new, 0, sizeof(PLpgSQL_stmt_getdiag));

						new->cmd_type = PLPGSQL_STMT_GETDIAG;
						new->lineno   = plpgsql_yyvsp[-2].ival;
						new->ndtitems = plpgsql_yyvsp[-1].dtlist.nused;
						new->dtitems  = malloc(sizeof(PLpgSQL_diag_item) * plpgsql_yyvsp[-1].dtlist.nused);
						memcpy(new->dtitems, plpgsql_yyvsp[-1].dtlist.dtitems, sizeof(PLpgSQL_diag_item) * plpgsql_yyvsp[-1].dtlist.nused);

						plpgsql_yyval.stmt = (PLpgSQL_stmt *)new;
					;
    break;}
case 66:
#line 634 "gram.y"
{
						if (plpgsql_yyvsp[-4].dtlist.nused == plpgsql_yyvsp[-4].dtlist.nalloc)
						{
							plpgsql_yyvsp[-4].dtlist.nalloc *= 2;
							plpgsql_yyvsp[-4].dtlist.dtitems = repalloc(plpgsql_yyvsp[-4].dtlist.dtitems, sizeof(PLpgSQL_diag_item) * plpgsql_yyvsp[-4].dtlist.nalloc);
						}
						plpgsql_yyvsp[-4].dtlist.dtitems[plpgsql_yyvsp[-4].dtlist.nused].target = plpgsql_yyvsp[-2].ival;
						plpgsql_yyvsp[-4].dtlist.dtitems[plpgsql_yyvsp[-4].dtlist.nused].item   = plpgsql_yyvsp[0].ival;
						plpgsql_yyvsp[-4].dtlist.nused++;

						plpgsql_yyval.dtlist.nalloc = plpgsql_yyvsp[-4].dtlist.nalloc;
						plpgsql_yyval.dtlist.nused  = plpgsql_yyvsp[-4].dtlist.nused;
						plpgsql_yyval.dtlist.dtitems = plpgsql_yyvsp[-4].dtlist.dtitems;
					;
    break;}
case 67:
#line 649 "gram.y"
{
						plpgsql_yyval.dtlist.nalloc = 1;
						plpgsql_yyval.dtlist.nused  = 1;
						plpgsql_yyval.dtlist.dtitems = palloc(sizeof(PLpgSQL_diag_item) * plpgsql_yyval.dtlist.nalloc);
						plpgsql_yyval.dtlist.dtitems[0].target = plpgsql_yyvsp[-2].ival;
						plpgsql_yyval.dtlist.dtitems[0].item   = plpgsql_yyvsp[0].ival;
					;
    break;}
case 68:
#line 659 "gram.y"
{
						plpgsql_yyval.ival = PLPGSQL_GETDIAG_ROW_COUNT;
					;
    break;}
case 69:
#line 663 "gram.y"
{
						plpgsql_yyval.ival = PLPGSQL_GETDIAG_RESULT_OID;
					;
    break;}
case 70:
#line 669 "gram.y"
{
						if (plpgsql_yylval.var->isconst)
						{
							plpgsql_comperrinfo();
							elog(ERROR, "%s is declared CONSTANT; can not receive diagnostics", plpgsql_yylval.var->refname);
						}
						plpgsql_yyval.ival = plpgsql_yylval.var->varno;
					;
    break;}
case 71:
#line 678 "gram.y"
{
						plpgsql_yyval.ival = plpgsql_yylval.recfield->rfno;
					;
    break;}
case 72:
#line 685 "gram.y"
{
						if (plpgsql_yylval.var->isconst)
						{
							plpgsql_comperrinfo();
							elog(ERROR, "%s is declared CONSTANT", plpgsql_yylval.var->refname);
						}
						plpgsql_yyval.ival = plpgsql_yylval.var->varno;
					;
    break;}
case 73:
#line 694 "gram.y"
{
						plpgsql_yyval.ival = plpgsql_yylval.recfield->rfno;
					;
    break;}
case 74:
#line 700 "gram.y"
{
						PLpgSQL_stmt_if *new;

						new = malloc(sizeof(PLpgSQL_stmt_if));
						memset(new, 0, sizeof(PLpgSQL_stmt_if));

						new->cmd_type	= PLPGSQL_STMT_IF;
						new->lineno		= plpgsql_yyvsp[-6].ival;
						new->cond		= plpgsql_yyvsp[-5].expr;
						new->true_body	= plpgsql_yyvsp[-4].stmts;
						new->false_body = plpgsql_yyvsp[-3].stmts;

						plpgsql_yyval.stmt = (PLpgSQL_stmt *)new;
					;
    break;}
case 75:
#line 717 "gram.y"
{
							PLpgSQL_stmts	*new;

							new = malloc(sizeof(PLpgSQL_stmts));
							memset(new, 0, sizeof(PLpgSQL_stmts));
							plpgsql_yyval.stmts = new;
					;
    break;}
case 76:
#line 725 "gram.y"
{ plpgsql_yyval.stmts = plpgsql_yyvsp[0].stmts; ;
    break;}
case 77:
#line 729 "gram.y"
{
						PLpgSQL_stmt_loop *new;

						new = malloc(sizeof(PLpgSQL_stmt_loop));
						memset(new, 0, sizeof(PLpgSQL_stmt_loop));

						new->cmd_type = PLPGSQL_STMT_LOOP;
						new->lineno   = plpgsql_yyvsp[-1].ival;
						new->label	  = plpgsql_yyvsp[-3].str;
						new->body	  = plpgsql_yyvsp[0].stmts;

						plpgsql_ns_pop();

						plpgsql_yyval.stmt = (PLpgSQL_stmt *)new;
					;
    break;}
case 78:
#line 747 "gram.y"
{
						PLpgSQL_stmt_while *new;

						new = malloc(sizeof(PLpgSQL_stmt_while));
						memset(new, 0, sizeof(PLpgSQL_stmt_while));

						new->cmd_type = PLPGSQL_STMT_WHILE;
						new->lineno   = plpgsql_yyvsp[-2].ival;
						new->label	  = plpgsql_yyvsp[-4].str;
						new->cond	  = plpgsql_yyvsp[-1].expr;
						new->body	  = plpgsql_yyvsp[0].stmts;

						plpgsql_ns_pop();

						plpgsql_yyval.stmt = (PLpgSQL_stmt *)new;
					;
    break;}
case 79:
#line 766 "gram.y"
{
						PLpgSQL_stmt_fori		*new;

						new = malloc(sizeof(PLpgSQL_stmt_fori));
						memset(new, 0, sizeof(PLpgSQL_stmt_fori));

						new->cmd_type = PLPGSQL_STMT_FORI;
						new->lineno   = plpgsql_yyvsp[-5].ival;
						new->label	  = plpgsql_yyvsp[-7].str;
						new->var	  = plpgsql_yyvsp[-4].var;
						new->reverse  = plpgsql_yyvsp[-2].forilow.reverse;
						new->lower	  = plpgsql_yyvsp[-2].forilow.expr;
						new->upper	  = plpgsql_yyvsp[-1].expr;
						new->body	  = plpgsql_yyvsp[0].stmts;

						plpgsql_ns_pop();

						plpgsql_yyval.stmt = (PLpgSQL_stmt *)new;
					;
    break;}
case 80:
#line 788 "gram.y"
{
						PLpgSQL_var		*new;

						new = malloc(sizeof(PLpgSQL_var));

						new->dtype		= PLPGSQL_DTYPE_VAR;
						new->refname	= plpgsql_yyvsp[0].varname.name;
						new->lineno		= plpgsql_yyvsp[0].varname.lineno;

						plpgsql_parse_word("integer");

						new->datatype	= plpgsql_yylval.dtype;
						new->isconst	= false;
						new->notnull	= false;
						new->default_val = NULL;

						plpgsql_adddatum((PLpgSQL_datum *)new);
						plpgsql_ns_additem(PLPGSQL_NSTYPE_VAR, new->varno,
												plpgsql_yyvsp[0].varname.name);

						plpgsql_add_initdatums(NULL);

						plpgsql_yyval.var = new;
					;
    break;}
case 81:
#line 815 "gram.y"
{
						plpgsql_yyval.varname.name = strdup(plpgsql_yytext);
						plpgsql_yyval.varname.lineno = plpgsql_yylineno;
					;
    break;}
case 82:
#line 820 "gram.y"
{
						plpgsql_yyval.varname.name = strdup(plpgsql_yytext);
						plpgsql_yyval.varname.lineno = plpgsql_yylineno;
					;
    break;}
case 83:
#line 827 "gram.y"
{
						int						tok;
						int						lno;
						PLpgSQL_dstring ds;
						int						nparams = 0;
						int						params[1024];
						char			buf[32];
						PLpgSQL_expr	*expr;
						int						firsttok = 1;

						lno = plpgsql_yylineno;
						plpgsql_dstring_init(&ds);
						plpgsql_dstring_append(&ds, "SELECT ");

						plpgsql_yyval.forilow.reverse = 0;
						while((tok = plpgsql_yylex()) != K_DOTDOT)
						{
							if (firsttok)
							{
								firsttok = 0;
								if (tok == K_REVERSE)
								{
									plpgsql_yyval.forilow.reverse = 1;
									continue;
								}
							}
							if (tok == ';') break;
							if (plpgsql_SpaceScanned)
								plpgsql_dstring_append(&ds, " ");
							switch (tok)
							{
								case T_VARIABLE:
									params[nparams] = plpgsql_yylval.var->varno;
									sprintf(buf, " $%d ", ++nparams);
									plpgsql_dstring_append(&ds, buf);
									break;

								case T_RECFIELD:
									params[nparams] = plpgsql_yylval.recfield->rfno;
									sprintf(buf, " $%d ", ++nparams);
									plpgsql_dstring_append(&ds, buf);
									break;

								case T_TGARGV:
									params[nparams] = plpgsql_yylval.trigarg->dno;
									sprintf(buf, " $%d ", ++nparams);
									plpgsql_dstring_append(&ds, buf);
									break;

								default:
									if (tok == 0)
									{
										plpgsql_error_lineno = lno;
										plpgsql_comperrinfo();
										elog(ERROR, "missing .. to terminate lower bound of for loop");
									}
									plpgsql_dstring_append(&ds, plpgsql_yytext);
									break;
							}
						}

						expr = malloc(sizeof(PLpgSQL_expr) + sizeof(int) * nparams - 1);
						expr->dtype				= PLPGSQL_DTYPE_EXPR;
						expr->query				= strdup(plpgsql_dstring_get(&ds));
						expr->plan				= NULL;
						expr->nparams	= nparams;
						while(nparams-- > 0)
							expr->params[nparams] = params[nparams];
						plpgsql_dstring_free(&ds);
						plpgsql_yyval.forilow.expr = expr;
					;
    break;}
case 84:
#line 900 "gram.y"
{
						PLpgSQL_stmt_fors		*new;

						new = malloc(sizeof(PLpgSQL_stmt_fors));
						memset(new, 0, sizeof(PLpgSQL_stmt_fors));

						new->cmd_type = PLPGSQL_STMT_FORS;
						new->lineno   = plpgsql_yyvsp[-5].ival;
						new->label	  = plpgsql_yyvsp[-7].str;
						switch (plpgsql_yyvsp[-4].rec->dtype)
						{
							case PLPGSQL_DTYPE_REC:
								new->rec = plpgsql_yyvsp[-4].rec;
								break;
							case PLPGSQL_DTYPE_ROW:
								new->row = (PLpgSQL_row *)plpgsql_yyvsp[-4].rec;
								break;
							default:
								plpgsql_comperrinfo();
								elog(ERROR, "unknown dtype %d in stmt_fors", plpgsql_yyvsp[-4].rec->dtype);
						}
						new->query = plpgsql_yyvsp[-1].expr;
						new->body  = plpgsql_yyvsp[0].stmts;

						plpgsql_ns_pop();

						plpgsql_yyval.stmt = (PLpgSQL_stmt *)new;
					;
    break;}
case 85:
#line 930 "gram.y"
{
						PLpgSQL_stmt_dynfors	*new;

						new = malloc(sizeof(PLpgSQL_stmt_dynfors));
						memset(new, 0, sizeof(PLpgSQL_stmt_dynfors));

						new->cmd_type = PLPGSQL_STMT_DYNFORS;
						new->lineno   = plpgsql_yyvsp[-5].ival;
						new->label	  = plpgsql_yyvsp[-7].str;
						switch (plpgsql_yyvsp[-4].rec->dtype)
						{
							case PLPGSQL_DTYPE_REC:
								new->rec = plpgsql_yyvsp[-4].rec;
								break;
							case PLPGSQL_DTYPE_ROW:
								new->row = (PLpgSQL_row *)plpgsql_yyvsp[-4].rec;
								break;
							default:
								plpgsql_comperrinfo();
								elog(ERROR, "unknown dtype %d in stmt_dynfors", plpgsql_yyvsp[-4].rec->dtype);
						}
						new->query = plpgsql_yyvsp[-1].expr;
						new->body  = plpgsql_yyvsp[0].stmts;

						plpgsql_ns_pop();

						plpgsql_yyval.stmt = (PLpgSQL_stmt *)new;
					;
    break;}
case 86:
#line 960 "gram.y"
{ plpgsql_yyval.rec = plpgsql_yylval.rec; ;
    break;}
case 87:
#line 962 "gram.y"
{
						plpgsql_yyval.rec = (PLpgSQL_rec *)(plpgsql_yylval.row);
					;
    break;}
case 88:
#line 968 "gram.y"
{
						plpgsql_yyval.stmt = make_select_stmt();
						plpgsql_yyval.stmt->lineno = plpgsql_yyvsp[0].ival;
					;
    break;}
case 89:
#line 975 "gram.y"
{
						PLpgSQL_stmt_exit *new;

						new = malloc(sizeof(PLpgSQL_stmt_exit));
						memset(new, 0, sizeof(PLpgSQL_stmt_exit));

						new->cmd_type = PLPGSQL_STMT_EXIT;
						new->lineno   = plpgsql_yyvsp[-2].ival;
						new->label	  = plpgsql_yyvsp[-1].str;
						new->cond	  = plpgsql_yyvsp[0].expr;

						plpgsql_yyval.stmt = (PLpgSQL_stmt *)new;
					;
    break;}
case 90:
#line 991 "gram.y"
{
						PLpgSQL_stmt_return *new;
						PLpgSQL_expr	*expr = NULL;
						int				tok;

						new = malloc(sizeof(PLpgSQL_stmt_return));
						memset(new, 0, sizeof(PLpgSQL_stmt_return));

						if (plpgsql_curr_compile->fn_retistuple)
						{
							new->retistuple = true;
							new->retrecno	= -1;
							switch (tok = plpgsql_yylex())
							{
								case K_NULL:
									expr = NULL;
									break;

								case T_ROW:
									expr = make_tupret_expr(plpgsql_yylval.row);
									break;

								case T_RECORD:
									new->retrecno = plpgsql_yylval.rec->recno;
									expr = NULL;
									break;

								default:
									plpgsql_yyerror("return type mismatch in function returning table row");
									break;
							}
							if (plpgsql_yylex() != ';')
								plpgsql_yyerror("expected ';'");
						} else {
							new->retistuple = false;
							expr = plpgsql_read_expression(';', ";");
						}

						new->cmd_type = PLPGSQL_STMT_RETURN;
						new->lineno   = plpgsql_yyvsp[0].ival;
						new->expr	  = expr;

						plpgsql_yyval.stmt = (PLpgSQL_stmt *)new;
					;
    break;}
case 91:
#line 1038 "gram.y"
{
						PLpgSQL_stmt_raise		*new;

						new = malloc(sizeof(PLpgSQL_stmt_raise));

						new->cmd_type	= PLPGSQL_STMT_RAISE;
						new->lineno		= plpgsql_yyvsp[-4].ival;
						new->elog_level = plpgsql_yyvsp[-3].ival;
						new->message	= plpgsql_yyvsp[-2].str;
						new->nparams	= plpgsql_yyvsp[-1].intlist.nused;
						new->params		= malloc(sizeof(int) * plpgsql_yyvsp[-1].intlist.nused);
						memcpy(new->params, plpgsql_yyvsp[-1].intlist.nums, sizeof(int) * plpgsql_yyvsp[-1].intlist.nused);

						plpgsql_yyval.stmt = (PLpgSQL_stmt *)new;
					;
    break;}
case 92:
#line 1054 "gram.y"
{
						PLpgSQL_stmt_raise		*new;

						new = malloc(sizeof(PLpgSQL_stmt_raise));

						new->cmd_type	= PLPGSQL_STMT_RAISE;
						new->lineno		= plpgsql_yyvsp[-3].ival;
						new->elog_level = plpgsql_yyvsp[-2].ival;
						new->message	= plpgsql_yyvsp[-1].str;
						new->nparams	= 0;
						new->params		= NULL;

						plpgsql_yyval.stmt = (PLpgSQL_stmt *)new;
					;
    break;}
case 93:
#line 1071 "gram.y"
{
						plpgsql_yyval.str = strdup(plpgsql_yytext);
					;
    break;}
case 94:
#line 1077 "gram.y"
{
						plpgsql_yyval.ival = ERROR;
					;
    break;}
case 95:
#line 1081 "gram.y"
{
						plpgsql_yyval.ival = NOTICE;
					;
    break;}
case 96:
#line 1085 "gram.y"
{
						plpgsql_yyval.ival = DEBUG;
					;
    break;}
case 97:
#line 1091 "gram.y"
{
						if (plpgsql_yyvsp[-1].intlist.nused == plpgsql_yyvsp[-1].intlist.nalloc)
						{
							plpgsql_yyvsp[-1].intlist.nalloc *= 2;
							plpgsql_yyvsp[-1].intlist.nums = repalloc(plpgsql_yyvsp[-1].intlist.nums, sizeof(int) * plpgsql_yyvsp[-1].intlist.nalloc);
						}
						plpgsql_yyvsp[-1].intlist.nums[plpgsql_yyvsp[-1].intlist.nused++] = plpgsql_yyvsp[0].ival;

						plpgsql_yyval.intlist.nalloc = plpgsql_yyvsp[-1].intlist.nalloc;
						plpgsql_yyval.intlist.nused  = plpgsql_yyvsp[-1].intlist.nused;
						plpgsql_yyval.intlist.nums   = plpgsql_yyvsp[-1].intlist.nums;
					;
    break;}
case 98:
#line 1104 "gram.y"
{
						plpgsql_yyval.intlist.nalloc = 1;
						plpgsql_yyval.intlist.nused  = 1;
						plpgsql_yyval.intlist.nums   = palloc(sizeof(int) * plpgsql_yyval.intlist.nalloc);
						plpgsql_yyval.intlist.nums[0] = plpgsql_yyvsp[0].ival;
					;
    break;}
case 99:
#line 1113 "gram.y"
{
						plpgsql_yyval.ival = plpgsql_yylval.var->varno;
					;
    break;}
case 100:
#line 1117 "gram.y"
{
						plpgsql_yyval.ival = plpgsql_yylval.recfield->rfno;
					;
    break;}
case 101:
#line 1121 "gram.y"
{
						plpgsql_yyval.ival = plpgsql_yylval.trigarg->dno;
					;
    break;}
case 102:
#line 1127 "gram.y"
{ plpgsql_yyval.stmts = plpgsql_yyvsp[-3].stmts; ;
    break;}
case 103:
#line 1131 "gram.y"
{
						PLpgSQL_stmt_execsql	*new;

						new = malloc(sizeof(PLpgSQL_stmt_execsql));
						new->cmd_type = PLPGSQL_STMT_EXECSQL;
						new->lineno   = plpgsql_yyvsp[0].ival;
						new->sqlstmt  = read_sqlstmt(';', ";", plpgsql_yyvsp[-1].str);

						plpgsql_yyval.stmt = (PLpgSQL_stmt *)new;
					;
    break;}
case 104:
#line 1144 "gram.y"
{
								PLpgSQL_stmt_dynexecute *new;

						new = malloc(sizeof(PLpgSQL_stmt_dynexecute));
						new->cmd_type = PLPGSQL_STMT_DYNEXECUTE;
						new->lineno   = plpgsql_yyvsp[-1].ival;
						new->query	  = plpgsql_yyvsp[0].expr;

						plpgsql_yyval.stmt = (PLpgSQL_stmt *)new;
						;
    break;}
case 105:
#line 1157 "gram.y"
{ plpgsql_yyval.str = strdup(plpgsql_yytext); ;
    break;}
case 106:
#line 1159 "gram.y"
{ plpgsql_yyval.str = strdup(plpgsql_yytext); ;
    break;}
case 107:
#line 1163 "gram.y"
{ plpgsql_yyval.expr = plpgsql_read_expression(';', ";"); ;
    break;}
case 108:
#line 1167 "gram.y"
{ plpgsql_yyval.expr = plpgsql_read_expression(K_THEN, "THEN"); ;
    break;}
case 109:
#line 1171 "gram.y"
{ plpgsql_yyval.expr = plpgsql_read_expression(K_LOOP, "LOOP"); ;
    break;}
case 110:
#line 1175 "gram.y"
{
						plpgsql_ns_push(NULL);
						plpgsql_yyval.str = NULL;
					;
    break;}
case 111:
#line 1180 "gram.y"
{
						plpgsql_ns_push(plpgsql_yyvsp[-2].str);
						plpgsql_yyval.str = plpgsql_yyvsp[-2].str;
					;
    break;}
case 112:
#line 1187 "gram.y"
{ plpgsql_yyval.str = NULL; ;
    break;}
case 113:
#line 1189 "gram.y"
{ plpgsql_yyval.str = strdup(plpgsql_yytext); ;
    break;}
case 114:
#line 1193 "gram.y"
{ plpgsql_yyval.expr = NULL; ;
    break;}
case 115:
#line 1195 "gram.y"
{ plpgsql_yyval.expr = plpgsql_yyvsp[0].expr; ;
    break;}
case 116:
#line 1199 "gram.y"
{ plpgsql_yyval.str = strdup(plpgsql_yytext); ;
    break;}
case 117:
#line 1203 "gram.y"
{
						plpgsql_error_lineno = plpgsql_yylineno;
						plpgsql_yyval.ival = plpgsql_yylineno;
					;
    break;}
}
   /* the action file gets copied in in place of this dollarsign */
#line 543 "/usr/local/share/bison.simple"

  plpgsql_yyvsp -= plpgsql_yylen;
  plpgsql_yyssp -= plpgsql_yylen;
#ifdef PLPGSQL_YYLSP_NEEDED
  plpgsql_yylsp -= plpgsql_yylen;
#endif

#if PLPGSQL_YYDEBUG != 0
  if (plpgsql_yydebug)
    {
      short *ssp1 = plpgsql_yyss - 1;
      fprintf (stderr, "state stack now");
      while (ssp1 != plpgsql_yyssp)
	fprintf (stderr, " %d", *++ssp1);
      fprintf (stderr, "\n");
    }
#endif

  *++plpgsql_yyvsp = plpgsql_yyval;

#ifdef PLPGSQL_YYLSP_NEEDED
  plpgsql_yylsp++;
  if (plpgsql_yylen == 0)
    {
      plpgsql_yylsp->first_line = plpgsql_yylloc.first_line;
      plpgsql_yylsp->first_column = plpgsql_yylloc.first_column;
      plpgsql_yylsp->last_line = (plpgsql_yylsp-1)->last_line;
      plpgsql_yylsp->last_column = (plpgsql_yylsp-1)->last_column;
      plpgsql_yylsp->text = 0;
    }
  else
    {
      plpgsql_yylsp->last_line = (plpgsql_yylsp+plpgsql_yylen-1)->last_line;
      plpgsql_yylsp->last_column = (plpgsql_yylsp+plpgsql_yylen-1)->last_column;
    }
#endif

  /* Now "shift" the result of the reduction.
     Determine what state that goes to,
     based on the state we popped back to
     and the rule number reduced by.  */

  plpgsql_yyn = plpgsql_yyr1[plpgsql_yyn];

  plpgsql_yystate = plpgsql_yypgoto[plpgsql_yyn - PLPGSQL_YYNTBASE] + *plpgsql_yyssp;
  if (plpgsql_yystate >= 0 && plpgsql_yystate <= PLPGSQL_YYLAST && plpgsql_yycheck[plpgsql_yystate] == *plpgsql_yyssp)
    plpgsql_yystate = plpgsql_yytable[plpgsql_yystate];
  else
    plpgsql_yystate = plpgsql_yydefgoto[plpgsql_yyn - PLPGSQL_YYNTBASE];

  goto plpgsql_yynewstate;

plpgsql_yyerrlab:   /* here on detecting error */

  if (! plpgsql_yyerrstatus)
    /* If not already recovering from an error, report this error.  */
    {
      ++plpgsql_yynerrs;

#ifdef PLPGSQL_YYERROR_VERBOSE
      plpgsql_yyn = plpgsql_yypact[plpgsql_yystate];

      if (plpgsql_yyn > PLPGSQL_YYFLAG && plpgsql_yyn < PLPGSQL_YYLAST)
	{
	  int size = 0;
	  char *msg;
	  int x, count;

	  count = 0;
	  /* Start X at -plpgsql_yyn if nec to avoid negative indexes in plpgsql_yycheck.  */
	  for (x = (plpgsql_yyn < 0 ? -plpgsql_yyn : 0);
	       x < (sizeof(plpgsql_yytname) / sizeof(char *)); x++)
	    if (plpgsql_yycheck[x + plpgsql_yyn] == x)
	      size += strlen(plpgsql_yytname[x]) + 15, count++;
	  msg = (char *) malloc(size + 15);
	  if (msg != 0)
	    {
	      strcpy(msg, "parse error");

	      if (count < 5)
		{
		  count = 0;
		  for (x = (plpgsql_yyn < 0 ? -plpgsql_yyn : 0);
		       x < (sizeof(plpgsql_yytname) / sizeof(char *)); x++)
		    if (plpgsql_yycheck[x + plpgsql_yyn] == x)
		      {
			strcat(msg, count == 0 ? ", expecting `" : " or `");
			strcat(msg, plpgsql_yytname[x]);
			strcat(msg, "'");
			count++;
		      }
		}
	      plpgsql_yyerror(msg);
	      free(msg);
	    }
	  else
	    plpgsql_yyerror ("parse error; also virtual memory exceeded");
	}
      else
#endif /* PLPGSQL_YYERROR_VERBOSE */
	plpgsql_yyerror("parse error");
    }

  goto plpgsql_yyerrlab1;
plpgsql_yyerrlab1:   /* here on error raised explicitly by an action */

  if (plpgsql_yyerrstatus == 3)
    {
      /* if just tried and failed to reuse lookahead token after an error, discard it.  */

      /* return failure if at end of input */
      if (plpgsql_yychar == PLPGSQL_YYEOF)
	PLPGSQL_YYABORT;

#if PLPGSQL_YYDEBUG != 0
      if (plpgsql_yydebug)
	fprintf(stderr, "Discarding token %d (%s).\n", plpgsql_yychar, plpgsql_yytname[plpgsql_yychar1]);
#endif

      plpgsql_yychar = PLPGSQL_YYEMPTY;
    }

  /* Else will try to reuse lookahead token
     after shifting the error token.  */

  plpgsql_yyerrstatus = 3;		/* Each real token shifted decrements this */

  goto plpgsql_yyerrhandle;

plpgsql_yyerrdefault:  /* current state does not do anything special for the error token. */

#if 0
  /* This is wrong; only states that explicitly want error tokens
     should shift them.  */
  plpgsql_yyn = plpgsql_yydefact[plpgsql_yystate];  /* If its default is to accept any token, ok.  Otherwise pop it.*/
  if (plpgsql_yyn) goto plpgsql_yydefault;
#endif

plpgsql_yyerrpop:   /* pop the current state because it cannot handle the error token */

  if (plpgsql_yyssp == plpgsql_yyss) PLPGSQL_YYABORT;
  plpgsql_yyvsp--;
  plpgsql_yystate = *--plpgsql_yyssp;
#ifdef PLPGSQL_YYLSP_NEEDED
  plpgsql_yylsp--;
#endif

#if PLPGSQL_YYDEBUG != 0
  if (plpgsql_yydebug)
    {
      short *ssp1 = plpgsql_yyss - 1;
      fprintf (stderr, "Error: state stack now");
      while (ssp1 != plpgsql_yyssp)
	fprintf (stderr, " %d", *++ssp1);
      fprintf (stderr, "\n");
    }
#endif

plpgsql_yyerrhandle:

  plpgsql_yyn = plpgsql_yypact[plpgsql_yystate];
  if (plpgsql_yyn == PLPGSQL_YYFLAG)
    goto plpgsql_yyerrdefault;

  plpgsql_yyn += PLPGSQL_YYTERROR;
  if (plpgsql_yyn < 0 || plpgsql_yyn > PLPGSQL_YYLAST || plpgsql_yycheck[plpgsql_yyn] != PLPGSQL_YYTERROR)
    goto plpgsql_yyerrdefault;

  plpgsql_yyn = plpgsql_yytable[plpgsql_yyn];
  if (plpgsql_yyn < 0)
    {
      if (plpgsql_yyn == PLPGSQL_YYFLAG)
	goto plpgsql_yyerrpop;
      plpgsql_yyn = -plpgsql_yyn;
      goto plpgsql_yyreduce;
    }
  else if (plpgsql_yyn == 0)
    goto plpgsql_yyerrpop;

  if (plpgsql_yyn == PLPGSQL_YYFINAL)
    PLPGSQL_YYACCEPT;

#if PLPGSQL_YYDEBUG != 0
  if (plpgsql_yydebug)
    fprintf(stderr, "Shifting error token, ");
#endif

  *++plpgsql_yyvsp = plpgsql_yylval;
#ifdef PLPGSQL_YYLSP_NEEDED
  *++plpgsql_yylsp = plpgsql_yylloc;
#endif

  plpgsql_yystate = plpgsql_yyn;
  goto plpgsql_yynewstate;

 plpgsql_yyacceptlab:
  /* PLPGSQL_YYACCEPT comes here.  */
  if (plpgsql_yyfree_stacks)
    {
      free (plpgsql_yyss);
      free (plpgsql_yyvs);
#ifdef PLPGSQL_YYLSP_NEEDED
      free (plpgsql_yyls);
#endif
    }
  return 0;

 plpgsql_yyabortlab:
  /* PLPGSQL_YYABORT comes here.  */
  if (plpgsql_yyfree_stacks)
    {
      free (plpgsql_yyss);
      free (plpgsql_yyvs);
#ifdef PLPGSQL_YYLSP_NEEDED
      free (plpgsql_yyls);
#endif
    }
  return 1;
}
#line 1209 "gram.y"


#ifndef PLPGSQL_YYBISON
#include "pl_scan.c" /* BSD yacc wants it here */
#endif


PLpgSQL_expr *
plpgsql_read_expression (int until, char *s)
{
	return read_sqlstmt(until, s, "SELECT ");
}


static PLpgSQL_expr *
read_sqlstmt (int until, char *s, char *sqlstart)
{
	int					tok;
	int					lno;
	PLpgSQL_dstring		ds;
	int					nparams = 0;
	int					params[1024];
	char				buf[32];
	PLpgSQL_expr		*expr;

	lno = plpgsql_yylineno;
	plpgsql_dstring_init(&ds);
	plpgsql_dstring_append(&ds, sqlstart);

	while((tok = plpgsql_yylex()) != until)
	{
		if (tok == ';') break;
		if (plpgsql_SpaceScanned)
			plpgsql_dstring_append(&ds, " ");
		switch (tok)
		{
			case T_VARIABLE:
				params[nparams] = plpgsql_yylval.var->varno;
				sprintf(buf, " $%d ", ++nparams);
				plpgsql_dstring_append(&ds, buf);
				break;

			case T_RECFIELD:
				params[nparams] = plpgsql_yylval.recfield->rfno;
				sprintf(buf, " $%d ", ++nparams);
				plpgsql_dstring_append(&ds, buf);
				break;

			case T_TGARGV:
				params[nparams] = plpgsql_yylval.trigarg->dno;
				sprintf(buf, " $%d ", ++nparams);
				plpgsql_dstring_append(&ds, buf);
				break;

			default:
				if (tok == 0)
				{
					plpgsql_error_lineno = lno;
					plpgsql_comperrinfo();
					elog(ERROR, "missing %s at end of SQL statement", s);
				}
				plpgsql_dstring_append(&ds, plpgsql_yytext);
				break;
		}
	}

	expr = malloc(sizeof(PLpgSQL_expr) + sizeof(int) * nparams - 1);
	expr->dtype			= PLPGSQL_DTYPE_EXPR;
	expr->query			= strdup(plpgsql_dstring_get(&ds));
	expr->plan			= NULL;
	expr->nparams		= nparams;
	while(nparams-- > 0)
		expr->params[nparams] = params[nparams];
	plpgsql_dstring_free(&ds);

	return expr;
}


static PLpgSQL_stmt *
make_select_stmt()
{
	int					tok;
	int					lno;
	PLpgSQL_dstring		ds;
	int					nparams = 0;
	int					params[1024];
	char				buf[32];
	PLpgSQL_expr		*expr;
	PLpgSQL_row			*row = NULL;
	PLpgSQL_rec			*rec = NULL;
	PLpgSQL_stmt_select *select;
	int					have_nexttok = 0;

	lno = plpgsql_yylineno;
	plpgsql_dstring_init(&ds);
	plpgsql_dstring_append(&ds, "SELECT ");

	while((tok = plpgsql_yylex()) != K_INTO)
	{
		if (tok == ';')
		{
			PLpgSQL_stmt_execsql		*execsql;

			expr = malloc(sizeof(PLpgSQL_expr) + sizeof(int) * nparams - 1);
			expr->dtype			= PLPGSQL_DTYPE_EXPR;
			expr->query			= strdup(plpgsql_dstring_get(&ds));
			expr->plan			= NULL;
			expr->nparams		= nparams;
			while(nparams-- > 0)
				expr->params[nparams] = params[nparams];
			plpgsql_dstring_free(&ds);

			execsql = malloc(sizeof(PLpgSQL_stmt_execsql));
			execsql->cmd_type = PLPGSQL_STMT_EXECSQL;
			execsql->sqlstmt  = expr;

			return (PLpgSQL_stmt *)execsql;
		}

		if (plpgsql_SpaceScanned)
			plpgsql_dstring_append(&ds, " ");
		switch (tok)
		{
			case T_VARIABLE:
				params[nparams] = plpgsql_yylval.var->varno;
				sprintf(buf, " $%d ", ++nparams);
				plpgsql_dstring_append(&ds, buf);
				break;

			case T_RECFIELD:
				params[nparams] = plpgsql_yylval.recfield->rfno;
				sprintf(buf, " $%d ", ++nparams);
				plpgsql_dstring_append(&ds, buf);
				break;

			case T_TGARGV:
				params[nparams] = plpgsql_yylval.trigarg->dno;
				sprintf(buf, " $%d ", ++nparams);
				plpgsql_dstring_append(&ds, buf);
				break;

			default:
				if (tok == 0)
				{
					plpgsql_error_lineno = plpgsql_yylineno;
					plpgsql_comperrinfo();
					elog(ERROR, "unexpected end of file");
				}
				plpgsql_dstring_append(&ds, plpgsql_yytext);
				break;
		}
	}

	tok = plpgsql_yylex();
	switch (tok)
	{
		case T_ROW:
			row = plpgsql_yylval.row;
			break;

		case T_RECORD:
			rec = plpgsql_yylval.rec;
			break;

		case T_VARIABLE:
		case T_RECFIELD:
			{
				PLpgSQL_var		*var;
				PLpgSQL_recfield *recfield;
				int				nfields = 1;
				char			*fieldnames[1024];
				int				varnos[1024];

				switch (tok)
				{	
					case T_VARIABLE:
						var = plpgsql_yylval.var;
						fieldnames[0] = strdup(plpgsql_yytext);
						varnos[0]	  = var->varno;
						break;

					case T_RECFIELD:
						recfield = plpgsql_yylval.recfield;
						fieldnames[0] = strdup(plpgsql_yytext);
						varnos[0]	  = recfield->rfno;
						break;
				}

				while ((tok = plpgsql_yylex()) == ',')
				{
					tok = plpgsql_yylex();
					switch(tok)
					{
						case T_VARIABLE:
							var = plpgsql_yylval.var;
							fieldnames[nfields] = strdup(plpgsql_yytext);
							varnos[nfields++]	= var->varno;
							break;

						case T_RECFIELD:
							recfield = plpgsql_yylval.recfield;
							fieldnames[0] = strdup(plpgsql_yytext);
							varnos[0]	  = recfield->rfno;
							break;

						default:
							elog(ERROR, "plpgsql: %s is not a variable or record field", plpgsql_yytext);
					}
				}
				row = malloc(sizeof(PLpgSQL_row));
				row->dtype = PLPGSQL_DTYPE_ROW;
				row->refname = strdup("*internal*");
				row->lineno = plpgsql_yylineno;
				row->rowtypeclass = InvalidOid;
				row->nfields = nfields;
				row->fieldnames = malloc(sizeof(char *) * nfields);
				row->varnos = malloc(sizeof(int) * nfields);
				while (--nfields >= 0)
				{
					row->fieldnames[nfields] = fieldnames[nfields];
					row->varnos[nfields] = varnos[nfields];
				}

				plpgsql_adddatum((PLpgSQL_datum *)row);

				have_nexttok = 1;
			}
			break;

		default:
			{
				if (plpgsql_SpaceScanned)
					plpgsql_dstring_append(&ds, " ");
				plpgsql_dstring_append(&ds, plpgsql_yytext);

				while(1)
				{
					tok = plpgsql_yylex();
					if (tok == ';')
					{
						PLpgSQL_stmt_execsql	*execsql;

						expr = malloc(sizeof(PLpgSQL_expr) + sizeof(int) * nparams - 1);
						expr->dtype				= PLPGSQL_DTYPE_EXPR;
						expr->query				= strdup(plpgsql_dstring_get(&ds));
						expr->plan				= NULL;
						expr->nparams	= nparams;
						while(nparams-- > 0) {
							expr->params[nparams] = params[nparams];
						}
						plpgsql_dstring_free(&ds);

						execsql = malloc(sizeof(PLpgSQL_stmt_execsql));
						execsql->cmd_type = PLPGSQL_STMT_EXECSQL;
						execsql->sqlstmt  = expr;

						return (PLpgSQL_stmt *)execsql;
					}

					if (plpgsql_SpaceScanned)
						plpgsql_dstring_append(&ds, " ");
					switch (tok)
					{
						case T_VARIABLE:
							params[nparams] = plpgsql_yylval.var->varno;
							sprintf(buf, " $%d ", ++nparams);
							plpgsql_dstring_append(&ds, buf);
							break;

						case T_RECFIELD:
							params[nparams] = plpgsql_yylval.recfield->rfno;
							sprintf(buf, " $%d ", ++nparams);
							plpgsql_dstring_append(&ds, buf);
							break;

						case T_TGARGV:
							params[nparams] = plpgsql_yylval.trigarg->dno;
							sprintf(buf, " $%d ", ++nparams);
							plpgsql_dstring_append(&ds, buf);
							break;

						default:
							if (tok == 0)
							{
								plpgsql_error_lineno = plpgsql_yylineno;
								plpgsql_comperrinfo();
								elog(ERROR, "unexpected end of file");
							}
							plpgsql_dstring_append(&ds, plpgsql_yytext);
							break;
					}
				}
			}
	}

	/************************************************************
	 * Eat up the rest of the statement after the target fields
	 ************************************************************/
	while(1)
	{
		if (!have_nexttok) {
			tok = plpgsql_yylex();
		}
		have_nexttok = 0;
		if (tok == ';') {
			break;
		}

		if (plpgsql_SpaceScanned)
			plpgsql_dstring_append(&ds, " ");
		switch (tok)
		{
			case T_VARIABLE:
				params[nparams] = plpgsql_yylval.var->varno;
				sprintf(buf, " $%d ", ++nparams);
				plpgsql_dstring_append(&ds, buf);
				break;

			case T_RECFIELD:
				params[nparams] = plpgsql_yylval.recfield->rfno;
				sprintf(buf, " $%d ", ++nparams);
				plpgsql_dstring_append(&ds, buf);
				break;

			case T_TGARGV:
				params[nparams] = plpgsql_yylval.trigarg->dno;
				sprintf(buf, " $%d ", ++nparams);
				plpgsql_dstring_append(&ds, buf);
				break;

			default:
				if (tok == 0)
				{
					plpgsql_error_lineno = plpgsql_yylineno;
					plpgsql_comperrinfo();
					elog(ERROR, "unexpected end of file");
				}
				plpgsql_dstring_append(&ds, plpgsql_yytext);
				break;
		}
	}

	expr = malloc(sizeof(PLpgSQL_expr) + sizeof(int) * (nparams - 1));
	expr->dtype			= PLPGSQL_DTYPE_EXPR;
	expr->query			= strdup(plpgsql_dstring_get(&ds));
	expr->plan			= NULL;
	expr->nparams		= nparams;
	while(nparams-- > 0)
		expr->params[nparams] = params[nparams];
	plpgsql_dstring_free(&ds);

	select = malloc(sizeof(PLpgSQL_stmt_select));
	memset(select, 0, sizeof(PLpgSQL_stmt_select));
	select->cmd_type = PLPGSQL_STMT_SELECT;
	select->rec		 = rec;
	select->row		 = row;
	select->query	 = expr;

	return (PLpgSQL_stmt *)select;
}


static PLpgSQL_expr *
make_tupret_expr(PLpgSQL_row *row)
{
	PLpgSQL_dstring		ds;
	PLpgSQL_expr		*expr;
	int					i;
	char				buf[16];

	expr = malloc(sizeof(PLpgSQL_expr) + sizeof(int) * (row->nfields - 1));
	expr->dtype			= PLPGSQL_DTYPE_EXPR;

	plpgsql_dstring_init(&ds);
	plpgsql_dstring_append(&ds, "SELECT ");

	for (i = 0; i < row->nfields; i++)
	{
		sprintf(buf, "%s$%d", (i > 0) ? "," : "", i + 1);
		plpgsql_dstring_append(&ds, buf);
		expr->params[i] = row->varnos[i];
	}

	expr->query			= strdup(plpgsql_dstring_get(&ds));
	expr->plan			= NULL;
	expr->plan_argtypes = NULL;
	expr->nparams		= row->nfields;

	plpgsql_dstring_free(&ds);
	return expr;
}
